﻿--[[
WarlockReminder v1.65
Date: 2011-11-30T08:00:35Z
Author: cklausi
Original Author of WarlockReminder: Vux of Dragonblight-US 
]]--

WarlockReminder = LibStub("AceAddon-3.0"):NewAddon("WarlockReminder", "AceConsole-3.0", "AceEvent-3.0", "AceTimer-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("WarlockReminder")
local media = LibStub("LibSharedMedia-3.0")

-- Default Values
local defaults = {
    profile = {
    	NewProfile = true,
		--Reminder
		ReminderEnable = true,
		ReminderHideResting = false,
		ReminderHideParty = false,
		showArmor = true,
		showSL = true,
		showFlask = true,
		showPet = true,
		showFood = true,
		showDI = true,
		showDemonicRebirth = true,
		-- Pets
		petAffliction = "felhunter",
		petDemonology = "felguard",
		petDestruction = "imp",
		-- DS
		DrainSoulEnable = true,
		DrainSoulSound = "Quaddamage",
		showDrainSoulMessage = false,
		drainSoulPercent = 25 / 100,
		drainSoulHealth = 1000,
		showDrainSoulFrame = true,
		drainSoulDuration = 5,
		-- Output
		outputFrame = "wlrframe",
		showTimeleft = true,
		timeleftFontsize = 12,
		timeleftFont = "Friz Quadrata TT",
		-- Anchor
		wlrAnchorTop = (UIParent:GetHeight()/2)+60, 
		wlrAnchorLeft = (UIParent:GetWidth()/2)-60,
		wlrAnchorAlpha = 1,
		wlrAnchorSize = 1,
		-- CD Anchor
		showCooldowns = true,
		cdAnchorTop = (UIParent:GetHeight()/2)+60, 
		cdAnchorLeft = (UIParent:GetWidth()/2)-250,
		CDGrowUp = false,
		CDs = {},
		cdFont = "Friz Quadrata TT",
		cdFontSize = 10,
		cdTextPosition = 1,
		cdAlpha = 1,
		cdBgColor = {
			r = 0.5,
			g = 0.5,
			b = 0.5,
			a = 1,
		},
		cdBg = "Blizzard Tooltip",
		cdTexture = "Blizzard",
		cdWidth = 160,
		cdHeight = 20,
		-- Decimation
		DecimationEnable = true,
		playDecimationSound = true,
		DecimationSound = "Quaddamage",
		showDecimationMessage = false,
		showDecimationFrame = true,
		-- MoltenCore
		MoltenCoreEnable = true,
		MoltenCoreSound = "Clearcasting",
		showMoltenCoreMessage = false,
		showMoltenCoreFrame = true,
		-- Shadow Trance
		ShadowTranceEnable = true,
		ShadowTranceSound = "Clearcasting",
		showShadowTranceMessage = false,
		showShadowTranceFrame = true,
		-- Empowered Imp
		EmpoweredImpEnable = true,
		EmpoweredImpSound = "Clearcasting",
		showEmpoweredImpMessage = false,
		showEmpoweredImpFrame = true,
		-- Dark Intent
		showDarkIntentFrame = true,
		diFrameTop = (UIParent:GetHeight()/2)-60,
		diFrameLeft = (UIParent:GetWidth()/2)-70,
		diFrameAlpha = 1,
		diBgColor = {
			r = 0.5,
			g = 0.5,
			b = 0.5,
			a = 1,
		},
		diBg = "Blizzard Tooltip",
		diBorder = "Blizzard Tooltip",
		diFrameSize = 1,
		diFrameShowRealm = false,
		diExtraWidth = 0,
		diFont = "Friz Quadrata TT",
		diFontSize = 11,
		diTTShow = true,
		diTTShowSpell = false,
		diTTPosition = "ANCHOR_CURSOR",
		-- ISF
		showIsf = true,
		isfInCombat = true,
		isfThreshold = 0,
		isfTop = (UIParent:GetHeight()/2)-60,
		isfLeft = (UIParent:GetWidth()/2)+70,
		isfTextPosition = 0,
		isfFont = "Friz Quadrata TT",
		isfFontSize = 10,
		isfAlpha = 1,
		isfBgColor = {
			r = 0.5,
			g = 0.5,
			b = 0.5,
			a = 1,
		},
		isfBg = "Blizzard Tooltip",
		isfTexture = "Blizzard",
		isfWidth = 160,
		isfHeight = 20,
		-- Custom
		showCustom = true,
		CustomSound = "Clearcasting",
		showCustomTimeleft = true,
		customTimeleftFontsize = 12,
		customTimeleftFont = "Friz Quadrata TT",
		wlrCustomAnchorTop = (UIParent:GetHeight()/2)+60,
		wlrCustomAnchorLeft = (UIParent:GetWidth()/2)+60,
		wlrCustomAnchorAlpha = 1,
		wlrCustomAnchorSize = 1,
		CustomSpells = {}
    },
}
-- END Default Values

-- Spell Ids
local FelArmor = 28176
local DemonArmor = 687
local SoulLink = 19028
local DrainSoul = 1120
local SoulFire = 6353
local DemonicRebirth = 88448

-- Flask
-- Wotlk
local FlaskOfFrostwyrm = 53755
local SpellpowerElixir = 33721
-- Cata
local ElixirOfTheMaster = 79635
local ElixirOfTheMightySpeed = 79632
local ElixirOfImpossibleAccuracy = 79481
local ElixirOfTheCobra = 79477
local FlaskOfTheDraconicMind = 79470
-- Well Fed
local WellFed = 57399 -- there are so many different buffs - using textures
local  _, _, WellFedIcon = GetSpellInfo(WellFed)

-- Pets
local Pets = {
	["imp"] = 688,
	["voidwalker"] = 697,
	["succubus"] = 712,
	["felhunter"] = 691,
	["felguard"] = 30146,
}
local petName = ""

-- Procs
local Decimation1 = 63165
local Decimation2 = 63167
local MoltenCore1 = 47383
local MoltenCore2 = 71162
local MoltenCore3 = 71165
local ShadowTrance = 17941
local EmpoweredImp = 54278
local Isf = 85383

-- Dark Intent
local DarkIntentSpell = 80398
local DarkIntent = 85767
local DarkIntentTarget = ""
local DiScan = {}
local DarkIntentMissing = false

-- Custom
local FelSpark = 89937

-- Variables
local wlrDB
local timeLeft = 0
local timeelapsedIsf = 0
local timeelapsedDi = 0
local CustomPlayed = false
local CustomShow = false
local DrainSoulPlayed = false
local DecimationPlayed = false
local ReminderPlayed = false
local DemonicRebirthPlayed = false
local _, englishClass = UnitClass("player")
local SelectedSpells = {}
local SelectedCDs = {}
local ConfigMode = false
local Bars = {}
Bars.__index = Bars
local cdBar = {}
local Cooldowns = {}

-- Frames
local wlranchor
local cdAnchor
local wlrframe
local wlrtexture
local diFrame
local diTextureFrame
local diFontFrame
local diFrameLock = true
local isfBar
local isfIcon
local isfLock = true
local wlrcustomanchor
local wlrcustomframe
local wlrcustomtexture
local wlrUnlockDialog

-- Addon start
function WarlockReminder:OnInitialize()
	if(englishClass == "WARLOCK") then
		self.db = LibStub("AceDB-3.0"):New("WarlockReminderDB", defaults, "Default")
		
		self:CreateFrames()
		
		self.db.RegisterCallback(self, "OnProfileChanged", "OnProfileChanged")
		self.db.RegisterCallback(self, "OnProfileCopied", "OnProfileChanged")
		self.db.RegisterCallback(self, "OnProfileReset", "OnProfileReset")
		self.db.RegisterCallback(self, "OnNewProfile", "OnNewProfile")
		
		wlrDB = self.db.profile
		
		self:CreateCooldownBars()
		self:DiFrameSetup()
		self:IsfSetup()
		
		self:SetUpOptions()
	end
end

function WarlockReminder:CreateDefaultTables()
	wlrDB.CDs = {
		[47241] = GetSpellInfo(47241),
		[77801] = GetSpellInfo(77801),
		[71521] = GetSpellInfo(71521),
		[47897] = GetSpellInfo(47897),
		[74434] = GetSpellInfo(74434),
		[29858] = GetSpellInfo(29858),
		[50796] = GetSpellInfo(50796),
		[48181] = GetSpellInfo(48181),
		[86121] = GetSpellInfo(86121),
		[6229] = GetSpellInfo(6229),
		[91713] = GetSpellInfo(91713),
		[48020] = GetSpellInfo(48020),
	}
	wlrDB.CustomSpells = {
		[89937] = GetSpellInfo(89937),
		[70840] = GetSpellInfo(70840),
	}
end

function WarlockReminder:OnEnable()
	if(englishClass == "WARLOCK") then
		self:RegisterEvent("PLAYER_TARGET_CHANGED")
		self:RegisterEvent("UNIT_COMBAT")
		self:RegisterEvent("UNIT_AURA")
		self:RegisterEvent("UNIT_PET")
		self:RegisterEvent("COMPANION_UPDATE")
		self:RegisterEvent("UNIT_SPELLCAST_SENT")
		self:RegisterEvent("PLAYER_REGEN_DISABLED")
		self:RegisterEvent("PLAYER_REGEN_ENABLED")
		
		media:Register("sound", "Quaddamage", "Interface\\AddOns\\WarlockReminder\\Sounds\\quaddamage.ogg")
		media:Register("sound", "Clearcasting", "Sound\\Spells\\Clearcasting_Impact_Chest.wav")
		
		-- Anchor Position
		if (not wlrDB.wlrAnchorLeft and not wlrDB.wlrAnchorTop) then
			wlranchor:Show()
			wlrDB.wlrAnchorLeft(wlranchor:GetLeft())
			wlrDB.wlrAnchorTop(wlranchor:GetTop())
		else
			self:AnchorSetup()
		end
		
		-- Anchor Position
		if (not wlrDB.cdAnchorLeft and not wlrDB.cdAnchorTop) then
			wlranchor:Show()
			wlrDB.cdAnchorLeft(cdAnchor:GetLeft())
			wlrDB.cdAnchorTop(cdAnchor:GetTop())
		else
			self:CDSetup()
		end
		
		-- CustomReminder Position
		if (not wlrDB.wlrCustomAnchorLeft and not wlrDB.wlrCustomAnchorTop) then
			wlrcustomanchor:Show()
			wlrDB.wlrCustomAnchorLeft(wlrcustomanchor:GetLeft())
			wlrDB.wlrCustomAnchorTop(wlrcustomanchor:GetTop())
		else
			self:CustomSetup()
		end
		
		-- DiFrame Position
		if (not wlrDB.diFrameLeft and not wlrDB.diFrameTop) then
			diFrame:Show()
			wlrDB.diFrameLeft(diFrame:GetLeft())
			wlrDB.diFrameTop(diFrame:GetTop())
		else
			self:DiFrameSetup()
		end
		
		-- Isf Position
		if (not wlrDB.isfLeft and not wlrDB.isfTop) then
			isfBar:Show()
			wlrDB.isfLeft(isfBar:GetLeft())
			wlrDB.isfTop(isfBar:GetTop())
		else
			self:IsfSetup()
		end
		
		if(wlrDB.NewProfile == true) then
			self:Unlock()
			wlrDB.NewProfile = false
		end
	end
end
-- END Addon start

local function round(number, decimals)
    return (("%%.%df"):format(decimals)):format(number)
end

-- Check if the unit has a buff
local function UnitHasBuff(unit, buff)
    for i=1, 40 do
		local name, _, iconTexture, count, _, _, expirationTime, source, _ = UnitBuff(unit, i)
        if ( name == GetSpellInfo(buff) ) then
			return true, iconTexture, count, expirationTime, source
        end
    end
	return false
end

-- Output Blizzard Message or Chat
function WarlockReminder:Output(input, red, green, blue, duration)
	-- Simulate default values, is there a better way to do this in lua?
	if(red == nil) then red = 0.0 end
	if(green == nil) then green = 1.0 end
	if(blue == nil) then blue = 0.0 end
	if(duration == nil) then duration = 5.0 end
	
	if(wlrDB.outputFrame == "chat") then
		self:Print(input)
	else
		UIErrorsFrame:AddMessage(input, red, green, blue, duration)
	end	
end

-- EVENTS


function WarlockReminder:UNIT_SPELLCAST_SENT(event, unit, spell, _, target)
	if(unit == "player" and spell == GetSpellInfo(DarkIntent)) then
		petName, _ = UnitName("pet")
		DarkIntentTarget = target
	end
end

function WarlockReminder:PLAYER_TARGET_CHANGED()
	DrainSoulPlayed = false
	DrainSoulShown = false
	ReminderPlayed = false
	if(ConfigMode == false) then
		self:DrainSoulReminder()
		self:Reminder()
	end
end

function WarlockReminder:PLAYER_REGEN_DISABLED()
	if(ConfigMode == false) then
		self:DrainSoulReminder()
	end
	if(wlrDB.showIsf == true) then isfBar:Show() end
end

function WarlockReminder:PLAYER_REGEN_ENABLED()
	self:ReminderPlayed()
	if(ConfigMode == false) then
		self:Reminder()
		if(wlrDB.isfInCombat == true) then 
			isfBar:Hide()
		end
	end
end

function WarlockReminder:UNIT_COMBAT(unit)
	if(ConfigMode == false) then
		self:DrainSoulReminder()
	end
end

function WarlockReminder:UNIT_AURA(event, unit)
	if(unit == "player" and ConfigMode == false) then
		self:Reminder()
	end
end

function WarlockReminder:UNIT_PET(event, unit)
	if(unit == "player" and ConfigMode == false) then
		self:Reminder()
	end
end

function WarlockReminder:COMPANION_UPDATE(event, companion)
	if(companion == "MOUNT" and ConfigMode == false) then
		self:Reminder()
	end
end
-- END EVENTS

function WarlockReminder:ReminderPlayed()
	if(not UnitHasBuff("player", ShadowTrance)) then
		ShadowTrancePlayed = false
	end
	if(not UnitHasBuff("player", EmpoweredImp)) then
		EmpoweredImpPlayed = false
	end
	if(not UnitHasBuff("player", Decimation1) and
		not UnitHasBuff("player", Decimation2)
	) then
		DecimationPlayed = false
	end
	if(not UnitHasBuff("player", MoltenCore1) and
		not UnitHasBuff("player", MoltenCore2) and
		not UnitHasBuff("player", MoltenCore3)
	) then
		MoltenCorePlayed = false
	end
	if(ShadowTrancePlayed == false and
		EmpoweredImpPlayed == false and
		DecimationPlayed == false and
		MoltenCorePlayed == false
	) then
		return false
	else
		return true
	end
end

-- Warlock reminder
function WarlockReminder:Reminder()
	if(DrainSoulShown or
		DrainSoulPlayed or
		DecimationPlayed or
		MoltenCorePlayed or
		ShadowTrancePlayed or
		EmpoweredImpPlayed
	) then 
		return
	end
	
	if(UnitIsDead("player") and 
		wlrDB.ReminderEnable == false
	) then
		self:WlrFrame(false)
		return
	end
	if(IsResting() and wlrDB.ReminderHideResting == true) then 
		self:WlrFrame(false)
		return
	end
	if((UnitInRaid("player") == nil or UnitInParty("player") == nil) and wlrDB.ReminderHideParty == true) then
		self:WlrFrame(false)
		return
	end

	local missing = false
	-- Bufffood
	if(wlrDB.showFood and
		UnitLevel("target") < 0 and
		UnitHealth("target") * 100 / UnitHealthMax("target") > 98 and
		select(2, UnitHasBuff("player", WellFed)) ~= WellFedIcon
	) then
		missing = true
		if(wlrDB.outputFrame == "wlrframe") then
			self:WlrFrame(true, WellFed)
		else
			self:Output("* ".. L["Missing Food"] .." *")
		end
	else
		if(not missing) then self:WlrFrame(false) end
	end

	-- Flask & Elixir
	if(wlrDB.showFlask and
		UnitLevel("target") < 0 and
		UnitHealth("target") * 100 / UnitHealthMax("target") > 98 and
		-- Wotlk
		not UnitHasBuff("player", FlaskOfFrostwyrm) and
		not UnitHasBuff("player", SpellpowerElixir) and
		-- Cata
		not UnitHasBuff("player", ElixirOfTheMaster) and
		not UnitHasBuff("player", ElixirOfTheMightySpeed) and
		not UnitHasBuff("player", ElixirOfImpossibleAccuracy) and
		not UnitHasBuff("player", ElixirOfTheCobra) and
		not UnitHasBuff("player", FlaskOfTheDraconicMind)
	) then
		missing = true
		if(wlrDB.outputFrame == "wlrframe") then
			self:WlrFrame(true, FlaskOfTheDraconicMind)
		else
			self:Output("* ".. L["Missing Flask"] .." *")
		end
	else
		if(not missing) then self:WlrFrame(false) end
	end

	-- Soul Link
	if(wlrDB.showSL and
		UnitExists("pet") and
		not IsMounted("player")
	) then
		if(not UnitHasBuff("player", SoulLink)) then
			missing = true
			if(wlrDB.outputFrame == "wlrframe") then
				self:WlrFrame(true, SoulLink)
			else
				self:Output("* ".. L["Missing SL"] .." *")
			end
		end
	else
		if(not missing) then self:WlrFrame(false) end
	end
	
	-- DI Missing
	if( wlrDB.showDI and 
		(DarkIntentMissing == true and showDarkIntentFrame == true) or not UnitHasBuff("player", DarkIntentSpell) and
		not IsMounted("player") ) then
		missing = true
		if(wlrDB.outputFrame == "wlrframe") then
			self:WlrFrame(true, DarkIntent)
		else
			self:Output("* ".. L["No DI"] .." *")
		end
	else
		if(not missing) then self:WlrFrame(false) end
	end

	-- Pet
	if(wlrDB.showPet and
		not UnitExists("pet") and
		not IsMounted("player")
	) then
		missing = true
		if(wlrDB.outputFrame == "wlrframe") then
			local talents = GetPrimaryTalentTree(false, false, GetActiveTalentGroup(false, false))
			if talents == 1 then self:WlrFrame(true, Pets[wlrDB.petAffliction]) -- Affli
			elseif (talents == 2) then self:WlrFrame(true, Pets[wlrDB.petDemonology]) -- Demo
			else self:WlrFrame(true, Pets[wlrDB.petDestruction]) end -- Destro + unknown
		else
			self:Output("* ".. L["Missing Pet"] .." *")
		end
	else
		if(not missing) then self:WlrFrame(false) end
	end
	
	-- Armor
	if(wlrDB.showArmor and
		not UnitHasBuff("player", FelArmor) and
		not UnitHasBuff("player", DemonArmor)
	) then
		missing = true
		if(wlrDB.outputFrame == "wlrframe") then
			self:WlrFrame(true, FelArmor)
		else 
			self:Output("* ".. L["Missing Armor"] .." *")
		end
	else
		if(not missing) then 
			self:WlrFrame(false)
		end
	end
	
	if( missing == true ) then
		ReminderPlayed = true
	else
		ReminderPlayed = false
	end
end

-- Demonic Rebirth
function WarlockReminder:DemonicRebirthReminder()
	if( wlrDB.showDemonicRebirth and UnitHasBuff("player", DemonicRebirth) ) then
		DemonicRebirthPlayed = true
		if(wlrDB.outputFrame == "wlrframe") then
			local _, _, _, expirationTime = UnitHasBuff("player", DemonicRebirth)
			self:WlrFrame(true, DemonicRebirth, expirationTime)
		else 
			self:Output("* ".. L["Demonic Rebirth"] .." *")
		end
	else 
		DemonicRebirthPlayed = false
	end
end

-- DrainSoul reminder
function WarlockReminder:DrainSoulReminder()
	if(	not ShadowTrancePlayed and -- don't show when Shadow Trance is up
		UnitCanAttack("player", "target") and
		not UnitIsDead("target") and
		UnitHealth("target") > 0 and
		UnitHealth("target") * 100 / UnitHealthMax("target") <= wlrDB.drainSoulPercent * 100 and
		UnitHealthMax("target") >= tonumber(wlrDB.drainSoulHealth) and
		wlrDB.DrainSoulEnable == true
		) then
			-- play ds sound
			if(not DrainSoulPlayed) then
				PlaySoundFile(media:Fetch("sound", wlrDB.DrainSoulSound))
			end
			-- show ds message
			if(wlrDB.showDrainSoulMessage and 
				not DrainSoulPlayed
			) then
				self:Output("* ".. L["Drain Soul!"] .." *", 1.0, 0.0, 0.0)
			end
			-- show ds wlrframe
			if(self.drainsoultimer) then local temptimer = self.drainsoultimer 
			else temptimer = nil end
			if(wlrDB.showDrainSoulFrame and
				not self:TimeLeft(temptimer) and
				not DrainSoulShown
			) then
				DrainSoulShown = true
				self:WlrDrainSoulFrame(true)
			end
			DrainSoulPlayed = true
	else 
		DrainSoulPlayed = false
		DrainSoulShown = false
	end
end

-- Decimation reminder
function WarlockReminder:DecimationReminder()
	if((UnitHasBuff("player", Decimation1) or
		UnitHasBuff("player", Decimation2)) and
		wlrDB.DecimationEnable == true
	) then
		-- play decimation sound
		if(not DecimationPlayed) then
			PlaySoundFile(media:Fetch("sound", wlrDB.DecimationSound))
		end
		-- show decimation message
		if(wlrDB.showDecimationMessage and 
			not DecimationPlayed
		) then
			self:Output("* ".. L["Decimation!"] .." *", 1.0, 0.0, 0.0)
		end
		-- show decimation frame
		if(wlrDB.showDecimationFrame) then
			local _, _, _, expirationTime = UnitHasBuff("player", Decimation2)
			self:WlrFrame(true, Decimation2, expirationTime)
		end
		DecimationPlayed = true
	else
		DecimationPlayed = false
	end
end

-- moltencore reminder
function WarlockReminder:MoltenCoreReminder()
	if((UnitHasBuff("player", MoltenCore1) or
		UnitHasBuff("player", MoltenCore2) or
		UnitHasBuff("player", MoltenCore3)) and
		not DecimationPlayed and  -- don't show when decimation is up
		wlrDB.MoltenCoreEnable == true
	) then
		-- play moltencore sound
		if(not MoltenCorePlayed) then
			PlaySoundFile(media:Fetch("sound", wlrDB.MoltenCoreSound))
		end
		-- show moltencore message
		if(wlrDB.showMoltenCoreMessage and 
			not MoltenCorePlayed
		) then
			self:Output("* ".. L["Molten Core!"] .." *", 1.0, 0.0, 0.0)
		end
		-- show moltencore frame
		if(wlrDB.showMoltenCoreFrame) then
			local count = 0
			local expirationTime
			if UnitHasBuff("player", MoltenCore1) then _, _, count, expirationTime = UnitHasBuff("player", MoltenCore1)
			elseif UnitHasBuff("player", MoltenCore2) then _, _, count, expirationTime = UnitHasBuff("player", MoltenCore2)
			else _, _, count, expirationTime = UnitHasBuff("player", MoltenCore3) end
			
			self:WlrMoltenCoreFrame(true, count, expirationTime)
		end
		MoltenCorePlayed = true
	else
		MoltenCorePlayed = false
	end
end

-- ShadowTrance reminder
function WarlockReminder:ShadowTranceReminder()
	if(UnitHasBuff("player", ShadowTrance) and
		wlrDB.ShadowTranceEnable == true
	) then
		-- play shadowtrance sound
		if(not ShadowTrancePlayed) then
			PlaySoundFile(media:Fetch("sound", wlrDB.ShadowTranceSound))
		end
		-- show shadowtrance message
		if(wlrDB.showShadowTranceMessage and 
			not ShadowTrancePlayed
		) then
			self:Output("* ".. L["Shadow Trance!"] .." *", 1.0, 0.0, 0.0)
		end
		-- show shadowtrance frame
		if(wlrDB.showShadowTranceFrame) then
			local _, _, _, expirationTime = UnitHasBuff("player", ShadowTrance)
			self:WlrFrame(true, ShadowTrance, expirationTime)
		end
		ShadowTrancePlayed = true
	else
		ShadowTrancePlayed = false
	end
end

-- EmpoweredImp reminder
function WarlockReminder:EmpoweredImpReminder()
	if(UnitHasBuff("player", EmpoweredImp) and
		wlrDB.EmpoweredImpEnable == true
	) then
		-- play empowered imp sound
		if(not EmpoweredImpPlayed) then
			PlaySoundFile(media:Fetch("sound", wlrDB.EmpoweredImpSound))
		end
		-- show empowered imp message
		if(wlrDB.showEmpoweredImpMessage and 
			not EmpoweredImpPlayed
		) then
			self:Output("* ".. L["Empowered Imp!"] .." *", 1.0, 0.0, 0.0)
		end
		-- show empowered imp frame
		if(wlrDB.showEmpoweredImpFrame) then
			local _, _, _, expirationTime = UnitHasBuff("player", EmpoweredImp)
			self:WlrFrame(true, EmpoweredImp, expirationTime)
		end
		EmpoweredImpPlayed = true
	else
		EmpoweredImpPlayed = false
	end
end

-- Dark Intent Tracker
function WarlockReminder:DarkIntentTracker()
	local output = 0
	if((UnitInRaid(DarkIntentTarget) or UnitInParty(DarkIntentTarget) or petName == DarkIntentTarget) and
		select(5, UnitHasBuff(DarkIntentTarget, DarkIntent)) == "player"
	)then
		local _, diTargetClass = UnitClass(DarkIntentTarget)
		local fontColor
		local diName
		local diRealm
		
		DarkIntentMissing = false
		
		if(not (DarkIntentTarget == "")) then
			local buffName, _, _, _, _, _, expirationTime, _, _ = UnitBuff(DarkIntentTarget, GetSpellInfo(DarkIntent))
			timeLeft = expirationTime
		end
		
		if((-1*(GetTime()-timeLeft)) < 0) then output = ""
		elseif((-1*(GetTime()-timeLeft)) >= 60) then output = format("%.0f",ceil(-1*(GetTime()-timeLeft)/60)).." "..L["minutes"]
		else output = format("%.0f",-1*(GetTime()-timeLeft)).." "..L["seconds"] end
		
		if(wlrDB.diFrameShowRealm == true) then
			diName = DarkIntentTarget
		else
			diName, diRealm = strsplit("-", DarkIntentTarget)
		end
		
		if(RAID_CLASS_COLORS[diTargetClass]) then
			local fontColor = RAID_CLASS_COLORS[diTargetClass]
			diFontFrame.text:SetTextColor(fontColor["r"], fontColor["g"], fontColor["b"])
		end
		diFontFrame.text:SetText(diName)
		diFontFrame.textTime:SetText(output)
		self:DiFrameSetFontGab()
	else
		timeLeft = 0
		diFontFrame.text:SetTextColor(1, 1, 1)
		diFontFrame.text:SetText(L["No DI"])
		diFontFrame.textTime:SetText("")
		DarkIntentMissing = true
	end
end

-- Tooltip: Scan party or raid for Di
function WarlockReminder:DarkIntentScan()
	DiScan = {}
	local party = ""
	local count = 1
	if(UnitInRaid("player")) then
		party = "raid"
		count = 40
	elseif(UnitInParty("player")) then
		party = "party"
		count = 4
	end
	
	if(party == "raid" or party == "party") then
		for i = 1, count, 1 do
			local _, _, _, _, unitCaster = UnitHasBuff(party..i, DarkIntent)
			if(unitCaster ~= "" and unitCaster ~= nil and unitCaster ~= false) then
				local name, _ = UnitName(party..i)
				local unitCaster, _ = UnitName(unitCaster)
				if(unitCaster ~= name) then
					if(name == nil) then name = " " end
					table.insert(DiScan, unitCaster..";"..name)
				end
			end
		end
	end
end

-- Isfreminder
function WarlockReminder:IsfReminder()
	if(wlrDB.showIsf) then
		local _, _, _, _, _, _, expirationTime = UnitBuff("player", GetSpellInfo(Isf))
		local _, _, _, _, _, _, castTime = GetSpellInfo(SoulFire)

		if(not (expirationTime == nil)) then
			local isfLeft = (-1*(GetTime()-expirationTime))
			isfBar:SetValue(isfLeft)
			isfBar.text:SetText(round(isfLeft, 1) .. L["seconds"])
			if(tonumber(isfLeft) < ((castTime/1000)+wlrDB.isfThreshold)) then isfBar:SetStatusBarColor(170/255, 10/255, 10/255, wlrDB.isfBgColor.a)
			elseif(tonumber(isfLeft) < ((castTime/1000)+1+wlrDB.isfThreshold)) then isfBar:SetStatusBarColor(255/255, 140/255, 10/255, wlrDB.isfBgColor.a)
			else isfBar:SetStatusBarColor(10/255, 170/255, 10/255, wlrDB.isfBgColor.a) end
		else
			isfBar:SetValue(0)
			isfBar.text:SetText(L["No Improved Soul Fire"])
		end
	end
end

-- OnUpdate
function WarlockReminder:OnUpdate(self, elapsed)
	timeelapsedDi = timeelapsedDi + elapsed
	timeelapsedIsf = timeelapsedIsf + elapsed
    if(timeelapsedDi >= 1) then
        WarlockReminder:DarkIntentTracker()
        timeelapsedDi = 0
    end
    if(timeelapsedIsf >= 0.05) then
      WarlockReminder:IsfReminder()
		if(ConfigMode == false) then
			WarlockReminder:ReminderPlayed()
			WarlockReminder:DecimationReminder()
			WarlockReminder:MoltenCoreReminder()
			WarlockReminder:ShadowTranceReminder()
			WarlockReminder:EmpoweredImpReminder()
			WarlockReminder:DrainSoulReminder()
			WarlockReminder:DemonicRebirthReminder()
			if(ShadowTrancePlayed == false and
				EmpoweredImpPlayed == false and
				DecimationPlayed == false and
				MoltenCorePlayed == false and
				DrainSoulPlayed == false and
				DemonicRebirthPlayed == false
			) then
				WarlockReminder:WlrFrame(false)
				WarlockReminder:Reminder()
			end
			WarlockReminder:CustomReminder()
			if(wlrDB.showCooldowns == true) then
				WarlockReminder:CooldownBars()
			end
		end
      timeelapsedIsf = 0
    end
end

function WarlockReminder:CreateCooldownBars()
	local i = 0
	for index, value in pairs(wlrDB.CDs) do
		i = i+1
		local SpellName = GetSpellInfo(index)
		Cooldowns[index] = {}
		Cooldowns[index]["cd"] = 0
		Cooldowns[index]["SpellName"] = SpellName
		Cooldowns[index]["Duration"] = ""
		Cooldowns[index]["Count"] = i
		Cooldowns[index]["active"] = false
		if(not cdBar[index]) then
			cdBar[index] = Bars:NewBar(index, SpellName, i)
			cdBar[index]:SetPoint()
			cdBar[index].bar:SetMinMaxValues(0, 1)
			cdBar[index]:Hide()
		end
	end
end

function WarlockReminder:CooldownBars()
	local i = 0
	for index, value in pairs(wlrDB.CDs) do
		if(value ~= nil) then
			local start, duration, _ = GetSpellCooldown(index)
			local cd = duration - (GetTime()-start)
			if(duration > 1.5) then
				local SpellName = GetSpellInfo(value)
				i = i+1
				Cooldowns[index]["cd"] = cd
				Cooldowns[index]["SpellName"] = SpellName
				Cooldowns[index]["Duration"] = duration
				Cooldowns[index]["Count"] = i
				Cooldowns[index]["active"] = true
			else
				Cooldowns[index]["active"] = false
			end
		end
	end
	
	for index, value in pairs(Cooldowns) do
		if(value["active"] == true and cdBar[index]) then
			if(value["cd"] > 0) then
				local output
				cdBar[index].bar:SetMinMaxValues(0, value["Duration"])
				cdBar[index]:SetValue(value["cd"])
				cdBar[index].count = value["Count"]
				cdBar[index]:SetPoint()
				if(value["cd"] <= 0) then output = value["SpellName"] .. " ready"
				elseif(value["cd"] >= 120) then output = format("%.0f",ceil(value["cd"]/60)).." "..L["minutes"]
				else output = format("%.0f",value["cd"]).." "..L["seconds"] end
				cdBar[index].text:SetText(output)
				cdBar[index]:Show()
			else
				cdBar[index]:Hide()
			end
		else
			if(cdBar[index]) then 
				cdBar[index]:Hide()
			end
		end
		if(ConfigMode == true and cdBar[index]) then cdBar[index]:Show() end
	end
end

-- Cooldowns
function WarlockReminder:GetListCDs()
	return wlrDB.CDs
end

function WarlockReminder:SetCurrentListCDs(info, key, value)
	if not value then
		value = nil
	end
	SelectedCDs[key] = value
end

function WarlockReminder:GetCurrentListCDs(info, key)
	return SelectedCDs[key];
end

function WarlockReminder:RemoveCooldown(info, value)
	if wlrDB.CDs ~= nil then
		for index, _ in pairs(SelectedCDs) do
			wlrDB.CDs[index] = nil
			table.remove(wlrDB.CDs, index)
			if(cdBar[index]) then
				Cooldowns[index]["active"] = false
				cdBar[index]:Hide()
			end
		end
	end
	SelectedCDs = {}
end

function WarlockReminder:AddCooldown(info, value)
	local found = false
	-- Cooldown already exists?
	for index, spell in pairs(wlrDB.CDs) do
		if(index == tonumber(value)) then
			found = true
			break
		end
	end
	-- Spell not in list -> add spell
	if(found == false) then
		wlrDB.CDs[tonumber(value)] = GetSpellInfo(value)
		self:CreateCooldownBars()
	end
end

-- Customreminder spells
function WarlockReminder:GetCustomSpells()
	return wlrDB.CustomSpells
end

function WarlockReminder:GetCurrentSpells(info, key)
	return SelectedSpells[key];
end

function WarlockReminder:SetCurrentSpells(info, key, value)
	if(not value) then
		value = nil;
	end
	SelectedSpells[key] = value;
end

function WarlockReminder:AddCustomSpell(info, value)
	local found = false
	-- Spell already exists?
	for index, spell in pairs(wlrDB.CustomSpells) do
		if(index == tonumber(value)) then
			found = true
			break
		end
	end
	-- Spell not in list -> add spell
	if(found == false) then
		wlrDB.CustomSpells[tonumber(value)] = GetSpellInfo(value)
	end
end

function WarlockReminder:RemoveCustomSpell(info, value)
	if wlrDB.CustomSpells ~= nil then
		for index, _ in pairs(SelectedSpells) do
			wlrDB.CustomSpells[index] = nil
			table.remove(wlrDB.CustomSpells, index)
		end
	end
	SelectedSpells = {}
end

-- Custom reminder
function WarlockReminder:CustomReminder()
	CustomShow = false
	if(wlrDB.showCustom) then
		for spell, _ in pairs(wlrDB.CustomSpells) do
			if(UnitHasBuff("player", spell)) then
				self:WlrCustomFrame(true, spell, select(3, UnitHasBuff("player", spell)), select(4, UnitHasBuff("player", spell)))
				CustomShow = true
				if(CustomPlayed == false) then
					PlaySoundFile(media:Fetch("sound", wlrDB.CustomSound))
					CustomPlayed = true
				end
				break
			end
		end
		if(CustomShow == false) then 
			CustomPlayed = false
			self:WlrCustomFrame(false)
		end
	end
end

-- Tooltip
local function OnEnter(self)
	if(wlrDB["diTTShow"] == false) then
		GameTooltip:Hide()
	else
		GameTooltip:SetOwner(self, wlrDB["diTTPosition"])
		if(wlrDB.diTTShowSpell == true) then
			GameTooltip:SetSpellByID(DarkIntentSpell)
		else
			GameTooltip:SetText(L["Dark Intent"])
		end
		WarlockReminder:DarkIntentScan()
		if(#(DiScan) > 0) then 
			GameTooltip:AddLine(" ", 1, 1, 1)
			if(wlrDB.diTTShowSpell == true) then GameTooltip:AddLine(L["Dark Intent Targets"], 1, 1, 1) end
			for _, unitCaster in pairs(DiScan) do
				local diCaster, diTarget = strsplit(";", unitCaster)
				local _, englishClassTarget = UnitClass(diTarget)
				local _, englishClassCaster = UnitClass(diCaster)
				local fontColorTarget = {}
				local fontColorCaster = {}
				if(RAID_CLASS_COLORS[englishClassCaster] == false) then
					fontColorCaster["r"] = 1
					fontColorCaster["g"] = 1
					fontColorCaster["b"] = 1
				else
					fontColorCaster = RAID_CLASS_COLORS[englishClassCaster]
				end
				if(RAID_CLASS_COLORS[englishClassTarget] == false) then
					fontColorTarget["r"] = 1
					fontColorTarget["g"] = 1
					fontColorTarget["b"] = 1
				else
					fontColorTarget = RAID_CLASS_COLORS[englishClassTarget]
				end
				GameTooltip:AddDoubleLine(diTarget, L["by"].." "..diCaster, fontColorTarget["r"], fontColorTarget["g"], fontColorTarget["b"], fontColorCaster["r"], fontColorCaster["g"], fontColorCaster["b"])
			end
		end
		GameTooltip:Show()
	end
end

local function OnLeave(self)
  GameTooltip:Hide()
end

-- Barfactory
function Bars:NewBar(SpellId, Text, Count)
	local self = {}
	setmetatable(self, Bars)
	
	self.count = Count
	
	self.bar = CreateFrame("StatusBar", nil, UIParent)
	self.bar:SetToplevel(1)
	self.bar:SetClampedToScreen(1)
	self.bar:SetOrientation("HORIZONTAL")
	
	self.bar:SetScript("OnUpdate", function(self, elapsed)
			WarlockReminder:OnUpdate(self, elapsed)
		end
	)
	
	self.icon = CreateFrame("Frame", nil, self.bar), {}
	self.icon:SetAlpha(1)
	self.icontexture = self.icon:CreateTexture()
	self.icontexture:SetTexture(GetSpellTexture(SpellId))
	self.icontexture:SetAllPoints(self.icon)
	self.icon:Show()
	
	if(Text) then
		self.text = self.bar:CreateFontString(Text, "OVERLAY", "GameFontHighlight")
		self:SetFont(wlrDB.cdFont, wlrDB.cdFontSize, wlrDB.cdTextPosition)
		self.text:SetText(Text)
	end

	self:SetTexture(media:Fetch("statusbar", wlrDB.cdTexture), media:Fetch("background", wlrDB.cdBg))
	self:SetColor({r = wlrDB.cdBgColor.r, g = wlrDB.cdBgColor.g, b = wlrDB.cdBgColor.b, a = wlrDB.cdBgColor.a}, {r = 10/255, g = 170/255, b = 10/255, a = 1})
	self:SetSize(wlrDB.cdWidth, wlrDB.cdHeight)
	self:SetAlpha(wlrDB.cdAlpha)
	
	return self
end

function Bars:Show()
	if(not self.bar:IsVisible()) then
		self.bar:Show()
	end
end

function Bars:Hide()
	if(self.bar:IsVisible()) then
		self.bar:Hide()
	end
end

function Bars:SetFont(font, fontsize, textposition)
	self.text:ClearAllPoints()
	self.text:SetFont(media:Fetch("font", font), fontsize, "OUTLINE")
	if(textposition == 0) then self.text:SetPoint("RIGHT",0,0)
	elseif(textposition == 1) then self.text:SetPoint("LEFT",0,0)
	else self.text:SetPoint("CENTER",0,0) end
end

function Bars:SetAlpha(alpha)
	self.bar:SetAlpha(wlrDB.cdAlpha)
end

function Bars:SetTexture(texture, bg)
	self.bar:SetBackdrop({bgFile = bg, 
									tile = true,
									tileSize = 16
								})
	self.bar:SetStatusBarTexture(texture)
end

function Bars:SetColor(bgColor, barColor)
	self.bar:SetBackdropColor(bgColor.r, bgColor.g, bgColor.b, bgColor.a)
	self.bar:SetStatusBarColor(barColor.r, barColor.g, barColor.b, barColor.a)
end

function Bars:SetCount(count)
	self.count = count
end

function Bars:GetCount()
	return self.count
end

function Bars:SetPoint()
	local padding = 1
	local growup = 1
	if(wlrDB.CDGrowUp) then growup = 1
	else growup = -1 end
	self.bar:SetPoint("CENTER", cdAnchor, "CENTER", 0, growup*((self.count*(self.bar:GetHeight()+padding))))
end

function Bars:SetSize(Width, Height)
	self.bar:SetWidth(Width)
	self.bar:SetHeight(Height)
	
	self.icon:SetWidth(self.bar:GetHeight())
	self.icon:SetHeight(self.bar:GetHeight())
	self.icon:SetPoint("LEFT", self.bar, "LEFT", -1*self.bar:GetHeight(), 0)
end

function Bars:GetValue()
	return self.bar:GetValue()
end

function Bars:SetValue(value)
	self.bar:SetValue(value)
end

function WarlockReminder:HideAllBars()
	for index, _ in pairs(cdBar) do
		if(cdBar[index]) then
			cdBar[index]:Hide()
		end
	end
end

function WarlockReminder:ShowAllBars()
	local i = 0
	for index, _ in pairs(cdBar) do
		if(cdBar[index]) then
			i = i+1
			cdBar[index].bar:SetMinMaxValues(0, 15)
			cdBar[index].count = i
			cdBar[index]:SetValue(15)
			cdBar[index]:SetPoint()
			cdBar[index].text:SetText(GetSpellInfo(index))
			cdBar[index]:Show()
		end
	end
end

function WarlockReminder:CreateFrames()
	-- Set up anchor
	wlranchor = CreateFrame("Frame", nil, UIParent), {}
	wlranchor:SetWidth(120)
	wlranchor:SetHeight(24)
	wlranchor:SetBackdrop({ bgFile = media:Fetch("background", "Blizzard Tooltip"), edgeFile = media:Fetch("border", "Blizzard Tooltip"), tile = true, tileSize = 8, edgeSize = 12, insets = { left = 2, right = 2, top = 2, bottom = 2 } })
	wlranchor:SetBackdropColor(0.1,0.1,0.2,1)
	wlranchor:SetBackdropBorderColor(0.1,0.1,0.1,1)
	wlranchor:SetMovable(1)
	wlranchor:EnableMouse(1)
	wlranchor:SetToplevel(1)
	wlranchor:SetClampedToScreen(1)
	wlranchor:SetPoint("CENTER")
	
	wlranchor.text = wlranchor:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
	wlranchor.text:SetText("Reminder")
	wlranchor.text:SetPoint("LEFT",6,0)

	wlranchor.close = CreateFrame("Button", nil, wlranchor, "UIPanelCloseButton")
	wlranchor.close:SetWidth(24)
	wlranchor.close:SetHeight(24)
	wlranchor.close:SetPoint("RIGHT")
	wlranchor:Hide()
	
	-- Move anchor
	wlranchor:SetScript("OnMouseDown", wlranchor.StartMoving)
	wlranchor:SetScript("OnMouseUp",
		function(self) 
			self:StopMovingOrSizing() 
			-- Set anchor
			wlrDB.wlrAnchorLeft = self:GetLeft()
			wlrDB.wlrAnchorTop = self:GetTop()
			WarlockReminder:FramesToAnchor()
		end
	)
	wlranchor:SetScript("OnEvent",function(self, event, ...) self[event](self, event, ...) end)
	-- END Set up anchor

	-- Set up frame
	wlrframe = CreateFrame("Frame", nil, UIParent), {}
	wlrtexture = wlrframe:CreateTexture()
	wlrtexture:SetAllPoints(wlrframe)
	wlrframe.text = wlrframe:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
	wlrframe.text:SetFont(media:Fetch("font", "Friz Quadrata TT"), 20, "OUTLINE")
	wlrframe.texttime = wlrframe:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
	wlrframe.texttime:SetPoint("BOTTOMRIGHT",-4,-16)
	wlrframe:Hide()

	-- Set up diFrame
	diFrame = CreateFrame("Button", nil, UIParent, "SecureActionButtonTemplate"), {}
	diFrame:RegisterForClicks("LeftButtonDown")
	diFrame:SetAttribute("type", "spell")
	diFrame:SetAttribute("unit", "target")
	diFrame:SetAttribute("spell", DarkIntentSpell)
	diFrame:SetMovable(1)
	diFrame:SetToplevel(1)
	diFrame:SetClampedToScreen(1)

	--Set up diTextureFrame
	diTextureFrame = CreateFrame("Frame", nil, diFrame), {}
	diTextureFrame:SetAlpha(0.75)
	diTextureFrame:SetPoint("LEFT", diFrame, 2, 0)
	diTexture = diTextureFrame:CreateTexture()
	diTexture:SetTexture(GetSpellTexture(DarkIntentSpell))
	diTexture:SetAllPoints(diTextureFrame)
	diTextureFrame:Show()

	-- Set up diFontFrame
	diFontFrame = CreateFrame("Frame", nil, diFrame), {}
	diFontFrame:SetAlpha(0.75)

	diFontFrame.text = diFontFrame:CreateFontString(nil,"ARTWORK","GameFontHighlight")
	diFontFrame.text:SetPoint("LEFT",5,6)

	diFontFrame.textTime = diFontFrame:CreateFontString(nil,"ARTWORK","GameFontHighlight")
	diFrame:Hide()
		
	diFrame:SetScript("OnUpdate", function(self, elapsed)
		WarlockReminder:OnUpdate(self, elapsed)
	end )
	
	-- Move Dark Intent
	diFrame:SetScript("OnMouseDown", 
		function(self)
			if(self:IsMovable() == 1) then
				self:StartMoving()
			end
		end
	)
	diFrame:SetScript("OnMouseUp",
		function(self) 
			if(self:IsMovable() == 1) then
				self:StopMovingOrSizing() 
				-- Set diFrame
				wlrDB.diFrameLeft = self:GetLeft()
				wlrDB.diFrameTop = self:GetTop() 
			end
		end
	)
	diFrame:SetScript("OnEvent",function(self,event,...) self[event](self,event,...) end)
	--END Set up diFrame
	
	-- Set up isfBar
	isfBar = CreateFrame("StatusBar", nil, UIParent), {}
	isfBar:SetMovable(1)
	isfBar:SetToplevel(1)
	isfBar:SetClampedToScreen(1)
	isfBar:SetOrientation("HORIZONTAL")
	isfBar:SetMinMaxValues(0, 15)
	isfBar:Hide()
	
	-- isfText
	isfBar.text = isfBar:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
	
	-- isfIcon
	isfIcon = CreateFrame("Frame", nil, isfBar), {}
	isfIcon:SetAlpha(0.75)
	isfIconTexture = isfIcon:CreateTexture()
	isfIconTexture:SetTexture(GetSpellTexture(SoulFire))
	isfIconTexture:SetAllPoints(isfIcon)
	isfIcon:Show()
	
	isfBar:SetScript("OnUpdate", function(self, elapsed)
		WarlockReminder:OnUpdate(self, elapsed)
	end )
	
	-- Move Isf
	isfBar:SetScript("OnMouseDown", 
		function(self)
			if(self:IsMovable() == 1) then
				self:StartMoving()
			end
		end
	)
	isfBar:SetScript("OnMouseUp",
		function(self) 
			if(self:IsMovable() == 1) then
				self:StopMovingOrSizing() 
				-- Set diFrame
				wlrDB.isfLeft = self:GetLeft()
				wlrDB.isfTop = self:GetTop()  
			end
		end
	)
	isfBar:SetScript("OnEvent",function(self,event,...) self[event](self,event,...) end)
	--END Set up isfBar
	
	-- Set up customanchor
	wlrcustomanchor = CreateFrame("Frame", nil, UIParent), {}
	wlrcustomanchor:SetWidth(120)
	wlrcustomanchor:SetHeight(24)
	wlrcustomanchor:SetBackdrop({ bgFile = media:Fetch("background", "Blizzard Tooltip"), edgeFile = media:Fetch("border", "Blizzard Tooltip"), tile = true, tileSize = 8, edgeSize = 12, insets = { left = 2, right = 2, top = 2, bottom = 2 } })
	wlrcustomanchor:SetBackdropColor(0.1, 0.1, 0.2, 1)
	wlrcustomanchor:SetBackdropBorderColor(0.1, 0.1, 0.1, 1)
	wlrcustomanchor:SetMovable(1)
	wlrcustomanchor:EnableMouse(1)
	wlrcustomanchor:SetToplevel(1)
	wlrcustomanchor:SetClampedToScreen(1)
	wlrcustomanchor:SetPoint("CENTER")
	wlrcustomanchor:Hide()

	wlrcustomanchor.text = wlrcustomanchor:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
	wlrcustomanchor.text:SetText("Custom Reminder")
	wlrcustomanchor.text:SetPoint("LEFT", 6, 0)

	wlrcustomanchor.close = CreateFrame("Button", nil, wlrcustomanchor,"UIPanelCloseButton")
	wlrcustomanchor.close:SetWidth(24)
	wlrcustomanchor.close:SetHeight(24)
	wlrcustomanchor.close:SetPoint("RIGHT")
	
	-- Set up customframe
	wlrcustomframe = CreateFrame("Frame", nil, UIParent), {}
	wlrcustomtexture = wlrcustomframe:CreateTexture()
	wlrcustomtexture:SetAllPoints(wlrcustomframe)
	wlrcustomframe.text = wlrcustomframe:CreateFontString(nil,"OVERLAY","GameFontHighlight")
	wlrcustomframe.text:SetFont(media:Fetch("font", "Friz Quadrata TT"), 20, "OUTLINE")
	wlrcustomframe.texttime = wlrcustomframe:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
	wlrcustomframe.texttime:SetPoint("BOTTOMRIGHT",-4,-16)
	wlrcustomframe:Hide()
	
	-- Move customanchor
	wlrcustomanchor:SetScript("OnMouseDown",wlrcustomanchor.StartMoving)
	wlrcustomanchor:SetScript("OnMouseUp",
		function(self) 
			self:StopMovingOrSizing() 
			-- Set anchor
			wlrDB.wlrCustomAnchorLeft = self:GetLeft()
			wlrDB.wlrCustomAnchorTop = self:GetTop() 
			WarlockReminder:FramesToAnchor()
		end
	)
	wlrcustomanchor:SetScript("OnEvent",function(self,event,...) self[event](self,event,...) end)
	
	-- Set up CD Anchor
	cdAnchor = CreateFrame("Frame", nil, UIParent), {}
	cdAnchor:SetWidth(120)
	cdAnchor:SetHeight(24)
	cdAnchor:SetBackdrop({ bgFile = media:Fetch("background", "Blizzard Tooltip"), edgeFile = media:Fetch("border", "Blizzard Tooltip"), tile = true, tileSize = 8, edgeSize = 12, insets = { left = 2, right = 2, top = 2, bottom = 2 } })
	cdAnchor:SetBackdropColor(0.1,0.1,0.2,1)
	cdAnchor:SetBackdropBorderColor(0.1,0.1,0.1,1)
	cdAnchor:SetMovable(1)
	cdAnchor:EnableMouse(1)
	cdAnchor:SetToplevel(1)
	cdAnchor:SetClampedToScreen(1)
	cdAnchor:SetPoint("CENTER")
	
	cdAnchor.text = cdAnchor:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
	cdAnchor.text:SetText("Cooldowns")
	cdAnchor.text:SetPoint("LEFT",6,0)

	cdAnchor.close = CreateFrame("Button", nil, cdAnchor, "UIPanelCloseButton")
	cdAnchor.close:SetWidth(24)
	cdAnchor.close:SetHeight(24)
	cdAnchor.close:SetPoint("RIGHT")
	cdAnchor:Hide()
	
	-- Move anchor
	cdAnchor:SetScript("OnMouseDown", cdAnchor.StartMoving)
	cdAnchor:SetScript("OnMouseUp",
		function(self) 
			self:StopMovingOrSizing() 
			-- Set anchor
			wlrDB.cdAnchorLeft = self:GetLeft()
			wlrDB.cdAnchorTop = self:GetTop()
			WarlockReminder:FramesToAnchor()
		end
	)
	cdAnchor:SetScript("OnEvent",function(self, event, ...) self[event](self, event, ...) end)
	-- END Set up anchor
end
-- END CreateFrames

function WarlockReminder:ResetAnchor()
	wlranchor:ClearAllPoints()
	wlranchor:SetPoint("CENTER",UIParent,"CENTER", 0, 0)
	wlrDB.wlranchor = wlranchor:GetLeft()
	wlrDB.wlranchor = wlranchor:GetTop() 
	WarlockReminder:FramesToAnchor()
	wlranchor:Show()
end

function WarlockReminder:ResetCustomAnchor()
	wlrcustomanchor:ClearAllPoints()
	wlrcustomanchor:SetPoint("CENTER",UIParent,"CENTER", 0, 0)
	wlrDB.wlrCustomAnchorLeft = wlrcustomanchor:GetLeft()
	wlrDB.wlrCustomAnchorTop = wlrcustomanchor:GetTop() 
	WarlockReminder:FramesToAnchor()
	wlrcustomanchor:Show()
end

function WarlockReminder:ResetDiFrame()
	diFrame:ClearAllPoints()
	diFrame:SetPoint("CENTER",UIParent,"CENTER", 0, 40)
	wlrDB.diFrameLeft = diFrame:GetLeft()
	wlrDB.diFrameTop = diFrame:GetTop() 
	diFrame:Show()
end

function WarlockReminder:ResetCooldowns()
	cdAnchor:ClearAllPoints()
	cdAnchor:SetPoint("CENTER",UIParent,"CENTER", 0, 0)
	wlrDB.cdAnchorLeft = cdAnchor:GetLeft()
	wlrDB.cdAnchorTop = cdAnchor:GetTop()
	cdAnchor:Show()
end

function WarlockReminder:ResetIsfBar()
	isfBar:ClearAllPoints()
	isfBar:SetPoint("CENTER",UIParent,"CENTER", 0, -40)
	wlrDB.isfLeft = isfBar:GetLeft()
	wlrDB.isfTop = isfBar:GetTop() 
	isfBar:Show()
end

function WarlockReminder:DiFrameSetFontGab()
	diFontFrame.text:SetPoint("LEFT",5,4+(0.2*diFontFrame.text:GetHeight()))
	diFontFrame.textTime:SetPoint("LEFT",5,-4-(0.2*diFontFrame.textTime:GetHeight()))
end

function WarlockReminder:UnlockFrame()
	if not wlrUnlockDialog then
		local f = CreateFrame("Frame", "WlrUnlockDialog", UIParent)
		f:SetFrameStrata("DIALOG")
		f:SetToplevel(true)
		f:EnableMouse(true)
		f:SetClampedToScreen(true)
		f:SetWidth(360)
		f:SetHeight(110)
		f:SetBackdrop{
			bgFile="Interface\\DialogFrame\\UI-DialogBox-Background" ,
			edgeFile="Interface\\DialogFrame\\UI-DialogBox-Border",
			tile = true,
			insets = {left = 11, right = 12, top = 12, bottom = 11},
			tileSize = 32,
			edgeSize = 32,
		}
		f:SetPoint("TOP", 0, -50)
		f:Hide()

		local tr = f:CreateTitleRegion()
		tr:SetAllPoints(f)

		local header = f:CreateTexture(nil, "ARTWORK")
		header:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Header")
		header:SetWidth(256); header:SetHeight(64)
		header:SetPoint("TOP", 0, 12)

		local title = f:CreateFontString("ARTWORK")
		title:SetFontObject("GameFontNormal")
		title:SetPoint("TOP", header, "TOP", 0, -14)
		title:SetText("WarlockReminder")

		local desc = f:CreateFontString("ARTWORK")
		desc:SetFontObject("GameFontHighlight")
		desc:SetJustifyV("TOP")
		desc:SetJustifyH("LEFT")
		desc:SetPoint("TOPLEFT", 18, -32)
		desc:SetPoint("BOTTOMRIGHT", -18, 48)
		desc:SetText(L["Frames unlocked. Move them now and click Lock when you are done."])

		local lockBars = CreateFrame("CheckButton", "WlrUnlockDialogLock", f, "OptionsButtonTemplate")
		getglobal(lockBars:GetName() .. "Text"):SetText(L["Lock"])

		lockBars:SetScript("OnClick", function(self)
			WarlockReminder:Lock()
			LibStub("AceConfigRegistry-3.0"):NotifyChange("WarlockReminder")
		end)

		--position buttons
		lockBars:SetPoint("BOTTOMRIGHT", -14, 14)

		wlrUnlockDialog = f
	end
	wlrUnlockDialog:Show()
end

function WarlockReminder:Lock()
	ConfigMode = false
	isfLock = true
	diFrameLock = true
	wlrcustomanchor:Hide()
	wlranchor:Hide()
	cdAnchor:Hide()
	wlrframe.texttime:SetText("")
	wlrcustomframe.texttime:SetText("")
	wlrUnlockDialog:Hide()
	self:AnchorSetup()
	self:CDSetup()
	self:CustomSetup()
	self:DiFrameSetup()
	self:IsfSetup()
	self:Reminder()
	wlrDB.NewProfile = false
end

function WarlockReminder:Unlock()
	ConfigMode = true
	isfLock = false
	diFrameLock = false
	wlrcustomanchor:Show()
	wlranchor:Show()
	cdAnchor:Show()
	isfBar:Show()
	self:WlrFrame(true, FelArmor)
	self:WlrCustomFrame(true, FelSpark, 0)
	wlrframe.texttime:SetText("10.0s")
	wlrcustomframe.texttime:SetText("10.0s")
	self:AnchorSetup()
	self:CDSetup()
	self:CustomSetup()
	self:DiFrameSetup()
	self:IsfSetup()
	self:UnlockFrame()
end

-- DiFrame Setup
function WarlockReminder:DiFrameSetup()
	diFrame:ClearAllPoints()
	-- Position
	diFrame:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", wlrDB.diFrameLeft, wlrDB.diFrameTop)
	
	-- Alpha
	diFrame:SetAlpha(wlrDB.diFrameAlpha)

	-- Size
	diFrame:SetWidth((132*wlrDB.diFrameSize)+wlrDB.diExtraWidth)
	diFrame:SetHeight(36*wlrDB.diFrameSize)
	diTextureFrame:SetWidth((36-4)*wlrDB.diFrameSize)
	diTextureFrame:SetHeight((36-4)*wlrDB.diFrameSize)
	diTexture:SetAllPoints(diTextureFrame)
	
	-- Border & Bg
	diFrame:SetBackdrop({ bgFile = media:Fetch("background", wlrDB.diBg), edgeFile = media:Fetch("border", wlrDB.diBorder), tile = false, tileSize = 16, edgeSize = 16, insets = { left = 2, right = 2, top = 2, bottom = 2 } })
	
	-- BG Alpha
	diFrame:SetBackdropColor(wlrDB.diBgColor.r, wlrDB.diBgColor.g, wlrDB.diBgColor.b, wlrDB.diBgColor.a)
	diFrame:SetBackdropBorderColor(wlrDB.diBgColor.r, wlrDB.diBgColor.g, wlrDB.diBgColor.b, wlrDB.diBgColor.a)
	
	-- Font
	diFontFrame:SetWidth((diFrame:GetWidth()-32)*wlrDB.diFrameSize)
	diFontFrame:SetHeight((diFrame:GetHeight()-4)*wlrDB.diFrameSize)
	diFontFrame:SetPoint("LEFT", diFrame, diTextureFrame:GetWidth(), 0)
	diFontFrame.textTime:SetFont(media:Fetch("font", wlrDB.diFont), wlrDB.diFontSize, "OUTLINE")
	diFontFrame.text:SetFont(media:Fetch("font", wlrDB.diFont), wlrDB.diFontSize, "OUTLINE")
	self:DiFrameSetFontGab()
	
	-- Movable
	if(diFrameLock == true) then 
		diFrame:SetMovable(0)
	else 
		diFrame:SetMovable(1) 
	end
	
	-- Show/Hide
	if(wlrDB.showDarkIntentFrame) then diFrame:Show()
	else diFrame:Hide() end
	
	-- Tooltip
	if(wlrDB.diTTShow == true) then
		diFrame:SetScript("OnEnter", OnEnter)
		diFrame:SetScript("OnLeave", OnLeave)
	end
end

-- ReminderFrame Setup
function WarlockReminder:AnchorSetup()
	wlranchor:ClearAllPoints()
	
	-- Position
	wlranchor:SetPoint("TOPLEFT",UIParent,"BOTTOMLEFT", wlrDB.wlrAnchorLeft, wlrDB.wlrAnchorTop)
	
	-- Alpha
	wlrframe:SetAlpha(wlrDB.wlrAnchorAlpha)

	-- Size
	wlrframe:SetWidth(48*wlrDB.wlrAnchorSize)
	wlrframe:SetHeight(48*wlrDB.wlrAnchorSize)
	
	-- Timeleft
	wlrframe.texttime:SetFont(media:Fetch("font", wlrDB.timeleftFont), wlrDB.timeleftFontsize, "OUTLINE")
	wlrframe.texttime:SetPoint("CENTER", 0, -1*(48*wlrDB.wlrAnchorSize)-15)
	
	self:FramesToAnchor()
	
	if(ConfigMode == false) then self:Reminder() end
	
	-- Show/Hide
	if(wlranchor:IsShown()) then 
		wlrframe:Show()
	else
		wlrframe:Hide()
		wlranchor:Hide()
	end
end

-- CD Setup
function WarlockReminder:CDSetup()
	cdAnchor:ClearAllPoints()
	
	-- Position
	cdAnchor:SetPoint("TOPLEFT",UIParent,"BOTTOMLEFT", wlrDB.cdAnchorLeft, wlrDB.cdAnchorTop)
	
	for index, _ in pairs(cdBar) do
		cdBar[index]:SetFont(wlrDB.cdFont, wlrDB.cdFontSize, wlrDB.cdTextPosition)
		cdBar[index]:SetTexture(media:Fetch("statusbar", wlrDB.cdTexture), media:Fetch("background", wlrDB.cdBg))
		cdBar[index]:SetColor({r = wlrDB.cdBgColor.r, g = wlrDB.cdBgColor.g, b = wlrDB.cdBgColor.b, a = wlrDB.cdBgColor.a}, {r = 10/255, g = 170/255, b = 10/255, a = 1})
		cdBar[index]:SetSize(wlrDB.cdWidth, wlrDB.cdHeight)
		cdBar[index]:SetAlpha(wlrDB.cdAlpha)
	end
	
	-- Show/Hide
	if(cdAnchor:IsShown() or wlrDB.showCooldowns or ConfigMode == true) then 
		self:ShowAllBars()
	else
		self:HideAllBars()
		cdAnchor:Hide()
	end
end

-- CustomReminder Setup
function WarlockReminder:CustomSetup()
	wlrcustomanchor:ClearAllPoints()
	
	-- Position
	wlrcustomanchor:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", wlrDB.wlrCustomAnchorLeft, wlrDB.wlrCustomAnchorTop)
	
	-- Alpha
	wlrcustomframe:SetAlpha(wlrDB.wlrCustomAnchorAlpha)
	
	-- Size
	wlrcustomframe:SetWidth(48*wlrDB.wlrCustomAnchorSize)
	wlrcustomframe:SetHeight(48*wlrDB.wlrCustomAnchorSize)
	
	-- Timeleft
	wlrcustomframe.texttime:SetFont(media:Fetch("font", wlrDB.customTimeleftFont), wlrDB.customTimeleftFontsize, "OUTLINE")
	wlrcustomframe.texttime:SetPoint("CENTER", 0, -1*(48*wlrDB.wlrCustomAnchorSize)-15)
	
	self:FramesToAnchor()
	
	if(ConfigMode == false) then self:CustomReminder() end
	
	-- Show/Hide
	if(wlrcustomanchor:IsShown()) then 
		wlrcustomframe:Show()
	else 
		wlrcustomframe:Hide() 
		wlrcustomanchor:Hide()
	end
	
end

-- Isfbar setup
function WarlockReminder:IsfSetup()
	isfBar:ClearAllPoints()
	-- Position
	isfBar:SetPoint("TOPLEFT",UIParent,"BOTTOMLEFT", wlrDB.isfLeft, wlrDB.isfTop)
	
	-- Text position
	isfBar.text:ClearAllPoints()
	if(wlrDB.isfTextPosition == 0) then isfBar.text:SetPoint("RIGHT",0,0)
	elseif(wlrDB.isfTextPosition == 1) then isfBar.text:SetPoint("LEFT",0,0)
	else isfBar.text:SetPoint("CENTER",0,0) end
	
	-- Font size
	isfBar.text:SetFont(media:Fetch("font", wlrDB.isfFont), wlrDB.isfFontSize, "OUTLINE")
	
	-- Alpha
	isfBar:SetAlpha(wlrDB.isfAlpha)
	
	-- Width & Height
	isfBar:SetWidth(wlrDB.isfWidth)
	isfBar:SetHeight(wlrDB.isfHeight)
	isfIcon:SetWidth(isfBar:GetHeight())
	isfIcon:SetHeight(isfBar:GetHeight())
	isfIcon:SetPoint("LEFT", isfBar, -1*(isfBar:GetHeight()), 0)
	
	-- Background
	isfBar:SetBackdrop({bgFile = media:Fetch("background", wlrDB.isfBg), tile = false, tileSize = 16})
	isfBar:SetBackdropColor(wlrDB.isfBgColor.r, wlrDB.isfBgColor.g, wlrDB.isfBgColor.b, wlrDB.isfBgColor.a)
	isfBar:SetStatusBarTexture(media:Fetch("statusbar", wlrDB.isfTexture))
	isfBar:SetStatusBarColor(wlrDB.isfBgColor.r, wlrDB.isfBgColor.g, wlrDB.isfBgColor.b, wlrDB.isfBgColor.a)

	-- Movable
	if(isfLock == true) then 
		isfBar:SetMovable(0)
	else 
		isfBar:SetMovable(1) 
	end
	
	-- Show/Hide
	if((wlrDB.showIsf and wlrDB.isfInCombat == false) or ConfigMode == true) then
		isfBar:Show()
	else 
		isfBar:Hide()
	end
end

-- Attach all frames to the anchor
function WarlockReminder:FramesToAnchor()
	wlrframe:SetPoint("CENTER",wlranchor,0,-42)
	wlrcustomframe:SetPoint("CENTER",wlrcustomanchor,0,-42) 
end

-- Show the customreminder frame
function WarlockReminder:WlrCustomFrame(show, texture, count, expirationTime)
	local timeleft
	
	if(texture) then wlrcustomtexture:SetTexture(GetSpellTexture(texture))
	else wlrcustomtexture:SetTexture(GetSpellTexture(89937)) end
	
	if(not count or count == 0) then count = "" end
	
	if(show) then
		if( expirationTime == nil or tonumber(expirationTime) == nil or wlrDB.showCustomTimeleft == false ) then timeleft = "" 
		else 
			timeleft = (-1*(GetTime()-expirationTime))
		end
		
		if(timeleft == "" or timeleft == nil) then wlrcustomframe.texttime:SetText("")
		else wlrcustomframe.texttime:SetText(tostring(round(timeleft, 1)) .. L["seconds"]) end
		
		wlrcustomframe.text:SetText(tostring(count))
		wlrcustomframe.text:SetPoint("BOTTOMRIGHT",-3,3)
		wlrcustomframe:Show()
	else 
		wlrcustomframe:Hide()
	end
end

-- Show the reminder frame
function WarlockReminder:WlrFrame(show, texture, expirationTime)
	local timeleft
	if(texture) then wlrtexture:SetTexture(GetSpellTexture(texture))
	else wlrtexture:SetTexture(GetSpellTexture(FelArmor)) end
	
	if(show) then 
		if( expirationTime == nil or tonumber(expirationTime) == nil or wlrDB.showTimeleft == false ) then timeleft = "" 
		else 
			timeleft = (-1*(GetTime()-expirationTime))
		end
		
		wlrframe.text:SetText("")
		if(timeleft == "" or timeleft == nil) then wlrframe.texttime:SetText("")
		else wlrframe.texttime:SetText(tostring(round(timeleft, 1)) .. L["seconds"]) end
		
		wlrframe:Show()
	else 
		wlrframe:Hide()
	end
end

-- Show the drain soul frame
function WarlockReminder:WlrDrainSoulFrame(show)
	if(show) then 
		wlrtexture:SetTexture(GetSpellTexture(DrainSoul))
		wlrframe.text:SetText("")
		wlrframe.texttime:SetText("")
		wlrframe:Show()
		self:CancelTimer(self.drainsoultimer, true)
		if(wlrDB.drainSoulDuration > 0) then
			self.drainsoultimer = self:ScheduleTimer("WlrDrainSoulFrame", wlrDB.drainSoulDuration, false)
		end
	else 
		self:CancelTimer(self.drainsoultimer, true)
		wlrframe:Hide() 
	end
end

-- Show the Molten Core Frame
function WarlockReminder:WlrMoltenCoreFrame(show, count, expirationTime)
	local timeleft
	if(not count) then count = 0 end
	if(show) then
		if( expirationTime == nil or tonumber(expirationTime) == nil or wlrDB.showTimeleft == false ) then timeleft = "" 
		else 
			timeleft = (-1*(GetTime()-expirationTime))
		end
		
		wlrtexture:SetTexture(GetSpellTexture(71165))
		wlrframe.text:SetText(tostring(count))
		wlrframe.text:SetPoint("BOTTOMRIGHT",-3,3)
		
		if(timeleft == "" or timeleft == nil) then wlrframe.texttime:SetText("")
		else wlrframe.texttime:SetText(tostring(round(timeleft, 1)) .. L["seconds"]) end
		
		wlrframe:Show()
	else
		wlrframe:Hide()
	end
end

local OutputFrames = {
	["chat"] = L["Chat"],
	["blizzard"] = L["Blizzard Message Frame"],
	["wlrframe"] = L["WarlockReminder Frame"],
}

local TextPositions = {
	[0] = L["Right"],
	[1] = L["Left"],
	[2] = L["Center"],
}

local PetChoice = {
	["felhunter"] = L["Felhunter"],
	["succubus"] = L["Succubus"],
	["imp"] = L["Imp"],
	["voidwalker"] = L["Voidwalker"],
	["felguard"] = L["Felguard"],
}

local TooltipPositions = {
	["ANCHOR_CURSOR"] = L["Cursor"],
	["ANCHOR_TOPLEFT"] = L["Top left"],
	["ANCHOR_TOPRIGHT"] = L["Top right"],
	["ANCHOR_BOTTOMLEFT"] = L["Bottom left"],
	["ANCHOR_BOTTOMRIGHT"] = L["Bottom right"],
	["ANCHOR_LEFT"] = L["Left"],
	["ANCHOR_RIGHT"] = L["Right"],
}

-- Options
local wlroptions = {
    name = "WarlockReminder",
    handler = WarlockReminder,
    type = "group",
	childGroups = "tree",
    args = {
    	config = {
			type = "execute",
			name = L["Configure"],
			desc = L["Open the options dialog of WarlockReminder"],
			func = function()
				InterfaceOptionsFrame_OpenToCategory(WarlockReminder.optionFrames.profile)
				InterfaceOptionsFrame_OpenToCategory(WarlockReminder.optionFrames.main)
			end,
			guiHidden = true,
		},
		configmode = {
			type = "execute",
			name = L["Config Mode"],
			desc = L["Config Mode"],
			func = "Unlock",
			guiHidden = true,
		},
		reminder = {
            type = "group",
			order = 0,
            name = L["Reminders"],
            args = {
            	enable = {
            		type = "toggle",
            		order  = 1,
            		name = L["Enable"],
            		desc = L["Enable"],
            		arg = "ReminderEnable",
            		get = "getProfileOption",
					set = "setProfileOption",
					width = "full",
            	},
            	resting = {
            		type = "toggle",
            		order  = 5,
            		name = L["Hide while resting"],
            		desc = L["Hide while resting"],
            		arg = "ReminderHideResting",
            		get = "getProfileOption",
					set = "setProfileOption",
            	},
            	party = {
            		type = "toggle",
            		order  = 6,
            		name = L["Hide without party"],
            		desc = L["Hide without party"],
            		arg = "ReminderHideParty",
            		get = "getProfileOption",
					set = "setProfileOption",
            	},
            	reminderheader = {
            		type = "header",
					order = 9,
					name = L["Reminders"],
            	},
				armor = {
					type = "toggle",
					order = 10,
					name = L["Armor"],
					desc = L["Show armor reminder"],
					arg = "showArmor",
					get = "getProfileOption",
					set = "setProfileOption",
				},
				darkintent = {
					type = "toggle",
					order = 15,
					name = L["Dark Intent"],
					desc = L["Dark Intent"],
					arg = "showDI",
					get = "getProfileOption",
					set = "setProfileOption",
				},
				demonicrebirth = {
					type = "toggle",
					order = 17,
					name = L["Demonic Rebirth"],
					desc = L["Demonic Rebirth"],
					arg = "showDemonicRebirth",
					get = "getProfileOption",
					set = "setProfileOption",
				},
				sl = {
					type = "toggle",
					order = 20,
					name = L["Soul Link"],
					desc = L["Show Soul Link reminder"],
					arg = "showSL",
					get = "getProfileOption",
					set = "setProfileOption",
				},
				flask = {
					type = "toggle",
					order = 30,
					name = L["Flask and Elixir"],
					desc = L["Show Flask and Elixir reminder"],
					arg = "showFlask",
					get = "getProfileOption",
					set = "setProfileOption",
				},
				food = {
					type = "toggle",
					order = 40,
					name = L["Well Fed"],
					desc = L["Show food reminder"],
					arg = "showFood",
					get = "getProfileOption",
					set = "setProfileOption",
				},
				pet = {
					type = "toggle",
					order = 50,
					name = L["Pet"],
					desc = L["Show pet reminder"],
					arg = "showPet",
					get = "getProfileOption",
					set = "setProfileOption",
					width = "full",
				},
				afflictionpet = {
					type = "select",
					name = L["Affliction"],
					desc = L["Pet for Affliction"],
					order = 60,
					values = PetChoice,
					arg = "petAffliction",
					get = "getProfileOption",
					set = "setProfileOption",
				},
				demonpet = {
					type = "select",
					name = L["Demonology"],
					desc = L["Pet for Demonology"],
					order = 70,
					values = PetChoice,
					arg = "petDemonology",
					get = "getProfileOption",
					set = "setProfileOption",
				},
				destrupet = {
					type = "select",
					name = L["Destruction"],
					desc = L["Pet for Destruction"],
					order = 80,
					values = PetChoice,
					arg = "petDestruction",
					get = "getProfileOption",
					set = "setProfileOption",
				},
			},
		},
		combat = {
            type = "group",
			order = 2,
            name = L["Combat Reminder"],
            args = {
				combatdesc = {
					order = 0,
					name = L["Combat reminder description"],
					type = "description",
				},
				drainsoul = {
					type = "group",
					order = 1,
					name = L["Drain Soul"],
					args = {
						enable = {
				    		type = "toggle",
				    		order  = 1,
				    		name = L["Enable"],
				    		desc = L["Enable"],
				    		arg = "DrainSoulEnable",
				    		get = "getProfileOption",
							set = "setProfileOption",
							width = "full",
				    	},
						sound = {
							type = 'select',
							dialogControl = 'LSM30_Sound',
							name = L["Sound reminder"],
							desc = L["Play Drain Soul sound reminder"],
							order = 10,
							values = AceGUIWidgetLSMlists.sound,
							arg = "DrainSoulSound",
							get = "getProfileOption",
							set = "setProfileOption",
						},
						message = {
							type = "toggle",
							name = L["Message reminder"],
							desc = L["Show Drain Soul message reminder"],
							order = 20,
							arg = "showDrainSoulMessage",
							get = "getProfileOption",
							set = "setProfileOption",
						},
						frame = {
							type = "toggle",
							name = L["Show Drain Soul Frame"],
							desc = L["Drain Soul will be shown in the WarlockReminder Frame"],
							order = 30,
							arg = "showDrainSoulFrame",
							get = "getProfileOption",
							set = "setProfileOption",
							width = "full",
						},
						percent = {
							type = "range",
							name = L["Show reminder at"],
							desc = L["Show Drain Soul reminder at"],
							order = 40,
							min = 0.0,
							max = 1.0,
							step = 0.01,
							isPercent = true,
							arg = "drainSoulPercent",
							get = "getProfileOption",
							set = "setProfileOption",
						},
						health = {
							type = "input",
							name = L["Minimum health"],
							desc = L["Minimum health to show the Drain Soul reminder"],
							order = 50,
							arg = "drainSoulHealth",
							get = "getProfileOption",
							set = "setProfileOption",
						},
						duration = {
							type = "range",
							name = L["Duration of Drain Soul Frame"],
							desc = L["How long the Drain Soul Frame will be shown"],
							order = 60,
							min = 0,
							max = 60,
							step = 1,
							isPercent = false,
							arg = "drainSoulDuration",
							get = "getProfileOption",
							set = "setProfileOption",
						},
					},
				}, -- END Drainsoul
				shadowtrance = {
					type = "group",
					order = 10,
					name = L["Shadow Trance"],
					args = {
						enable = {
				    		type = "toggle",
				    		order  = 1,
				    		name = L["Enable"],
				    		desc = L["Enable"],
				    		arg = "ShadowTranceEnable",
				    		get = "getProfileOption",
							set = "setProfileOption",
							width = "full",
				    	},
						sound = {
							type = 'select',
							name = L["Sound reminder"],
							desc = L["Play Shadow Trance sound reminder"],
							order = 10,
							dialogControl = 'LSM30_Sound',
							values = AceGUIWidgetLSMlists.sound,
							arg = "ShadowTranceSound",
							get = "getProfileOption",
							set = "setProfileOption",
						},
						message = {
							type = "toggle",
							name = L["Message reminder"],
							desc = L["Show Shadow Trance message reminder"],

							order = 20,
							arg = "showShadowTranceMessage",
							get = "getProfileOption",
							set = "setProfileOption",
						},
						frame = {
							type = "toggle",
							name = L["Show Shadow Trance Frame"],
							desc = L["Show Shadow Trance Frame"],
							order = 30,
							arg = "showShadowTranceFrame",
							get = "getProfileOption",
							set = "setProfileOption",
						},
					},
				}, -- END Shadow Trance
				decimation = {
					type = "group",
					order = 20,
					name = L["Decimation"],
					args = {
						enable = {
				    		type = "toggle",
				    		order  = 1,
				    		name = L["Enable"],
				    		desc = L["Enable"],
				    		arg = "DecimationEnable",
				    		get = "getProfileOption",
							set = "setProfileOption",
							width = "full",
				    	},
						sound = {
							type = 'select',
							name = L["Sound reminder"],
							desc = L["Play Decimation sound reminder"],
							order = 10,
							dialogControl = 'LSM30_Sound',
							values = AceGUIWidgetLSMlists.sound,
							arg = "DecimationSound",
							get = "getProfileOption",
							set = "setProfileOption",
						},
						message = {
							type = "toggle",
							name = L["Message reminder"],
							desc = L["Show Decimation message reminder"],
							order = 20,
							arg = "showDecimationMessage",
							get = "getProfileOption",
							set = "setProfileOption",
						},
						frame = {
							type = "toggle",
							name = L["Show Decimation Frame"],
							desc = L["Show Decimation Frame"],
							order = 30,
							arg = "showDecimationFrame",
							get = "getProfileOption",
							set = "setProfileOption",
						},
					},
				}, -- END Decimation
				moltencore = {
					type = "group",
					order = 30,
					name = L["Molten Core"],
					args = {
						enable = {
				    		type = "toggle",
				    		order  = 1,
				    		name = L["Enable"],
				    		desc = L["Enable"],
				    		arg = "MoltenCoreEnable",
				    		get = "getProfileOption",
							set = "setProfileOption",
							width = "full",
				    	},
						sound = {
							type = 'select',
							name = L["Sound reminder"],
							desc = L["Play Molten Core sound reminder"],
							order = 10,
							dialogControl = 'LSM30_Sound',
							values = AceGUIWidgetLSMlists.sound,
							arg = "MoltenCoreSound",
							get = "getProfileOption",
							set = "setProfileOption",
						},
						message = {
							type = "toggle",
							name = L["Message reminder"],
							desc = L["Show Molten Core message reminder"],
							order = 20,
							arg = "showMoltenCoreMessage",
							get = "getProfileOption",
							set = "setProfileOption",
						},
						frame = {
							type = "toggle",
							name = L["Show Molten Core Frame"],
							desc = L["Show Molten Core Frame"],
							order = 30,
							arg = "showMoltenCoreFrame",
							get = "getProfileOption",
							set = "setProfileOption",
						},
					},
				}, -- END Molten Core
				empoweredimp = {
					type = "group",
					order = 50,
					name = L["Empowered Imp"],
					args = {
						enable = {
				    		type = "toggle",
				    		order  = 1,
				    		name = L["Enable"],
				    		desc = L["Enable"],
				    		arg = "EmpoweredImpEnable",
				    		get = "getProfileOption",
							set = "setProfileOption",
							width = "full",
				    	},
						sound = {
							type = 'select',
							name = L["Sound reminder"],
							desc = L["Play Empowered Imp sound reminder"],
							order = 10,
							dialogControl = 'LSM30_Sound',
							values = AceGUIWidgetLSMlists.sound,
							arg = "EmpoweredImpSound",
							get = "getProfileOption",
							set = "setProfileOption",
						},
						message = {
							type = "toggle",
							name = L["Message reminder"],
							desc = L["Show Empowered Imp message reminder"],
							order = 20,
							arg = "showEmpoweredImpMessage",
							get = "getProfileOption",
							set = "setProfileOption",
						},
						frame = {
							type = "toggle",
							name = L["Show Empowered Imp Frame"],
							desc = L["Show Empowered Imp Frame"],
							order = 30,
							arg = "showEmpoweredImpFrame",
							get = "getProfileOption",
							set = "setProfileOption",
						},
					},
				},-- END Empowered Imp
			},
		},
		-- CustomReminder
		customreminder = {
			type = "group",
			order = 3,
			name = L["Custom Reminder"],
			args = {
				enable = {
					type = "toggle",
					order = 20,
					name = L["Show Custom Reminder"],
					desc = L["Show Custom Reminder"],
					arg = "showCustom",
					get = "getProfileOption",
					set = "setProfileOption",
					width = "full",
				},
				configmode = {
					type = "execute",
					name = L["Config Mode"],
					desc = L["Config Mode"],
					order = 30,
					func = "Unlock",
				},
				reset = {
					type = "execute",
					name = L["Reset position"],
					desc = L["Anchor Reset"],
					order = 40,
					func = "ResetCustomAnchor",
				},
				sound = {
					type = 'select',
					name = L["Sound reminder"],
					desc = L["Sound reminder"],
					order = 50,
					dialogControl = 'LSM30_Sound',
					values = AceGUIWidgetLSMlists.sound,
					arg = "CustomSound",
					get = "getProfileOption",
					set = "setProfileOption",
				},
				alpha = {
					type = "range",

					name = L["Frame alpha"],
					desc = L["Frame alpha"],
					order = 60,
					min = 0.0,
					softMin = 0.25,
					max = 1.0,
					step = 0.05,
					isPercent = true,
					arg = "wlrCustomAnchorAlpha",
					get = "getProfileOption",
					set = "setProfileOption",
				},
				size = {
					type = "range",
					name = L["Frame size"],
					desc = L["Frame size"],
					order = 70,
					min = 0.01,
					softMin = 0.25,
					max = 3,
					softMax = 2,
					step = 0.01,
					isPercent = true,
					arg = "wlrCustomAnchorSize",
					get = "getProfileOption",
					set = "setProfileOption",
				},
				customtimeleftheader = {
					type = "header",
					order = 80,
					name = L["Show time left"],
				},
				timeleft = {
					type = "toggle",
					order = 90,
					name = L["Show time left"],
					desc = L["Show time left"],
					arg = "showCustomTimeleft",
					get = "getProfileOption",
					set = "setProfileOption",
					width = "full",
				},
				font = {
					type = 'select',
					dialogControl = 'LSM30_Font',
					name = L["Font"],
					desc = L["Font"],
					values = AceGUIWidgetLSMlists.font,
					arg = "customTimeleftFont",
					get = "getProfileOption",
					set = "setProfileOption",
					order = 100,
				},
				fontsize = {
					type = "range",
					name = L["Font size"],
					desc = L["Font size"],
					order = 110,
					min = 0.00,
					softMin = 7,
					max = 32,
					step = 1,
					arg = "customTimeleftFontsize",
					get = "getProfileOption",
					set = "setProfileOption",
				},
				remindersetup = {
					type = "group",
					order = 1,
					name = L["Spell setup"],
					args = {
						addspell = {
							name = L["Add a Spell"],
							desc = L["Add a new spell to the list by entering the Spell-Id here."],
							type = "input",
							order = 10,
							get = false,
							set = "AddCustomSpell",
							width = "double",
						},
						selectspell = {
							name = "",
							desc = "",
							type = "multiselect",
							order = 20,
							get = "GetCurrentSpells",
							set = "SetCurrentSpells",
							values = "GetCustomSpells",
							width = "double",
						},
						removespell = {
							name = L["Remove Spell"],
							desc = L["Remove the selected spell from the list."],
							type = "execute",
							func = "RemoveCustomSpell",
							order = 30,
						},
						customdesc = {
							order = 100,
							name = L["Use spell-ids from wowhead.com's Urls, e.g. Devious Minds: http://www.wowhead.com/spell=70840 => Spell-Id: 70840"],
							type = "description",
						},
					},
				},
			},
		}, -- END CustomReminder
		output = {
            type = "group",
			order = 4,
            name = L["Output Frame"],
            args = {
				frame = {
					type = "select",
					name = L["Output Frame"],
					desc = L["Reminders will be shown in the selected frame"],
					order = 10,
					values = OutputFrames,
					arg = "outputFrame",
					get = "getProfileOption",
					set = "setProfileOption",
				},
				anchorheader = {
					type = "header",
					order = 20,
					name = L["WarlockReminder Frame"],
				},
				configmode = {
					type = "execute",
					name = L["Config Mode"],
					desc = L["Config Mode"],
					order = 30,
					func = "Unlock",
				},
				reset = {
					type = "execute",
					name = L["Reset position"],
					desc = L["Anchor Reset"],
					order = 40,
					func = "ResetAnchor",
				},
				alpha = {
					type = "range",
					name = L["Frame alpha"],
					desc = L["Frame alpha"],
					order = 50,
					min = 0.0,
					softMin = 0.25,
					max = 1.0,
					step = 0.05,
					isPercent = true,
					arg = "wlrAnchorAlpha",
					get = "getProfileOption",
					set = "setProfileOption",
				},
				size = {
					type = "range",
					name = L["Frame size"],
					desc = L["Frame size"],
					order = 60,
					min = 0.01,
					softMin = 0.25,
					max = 3,
					softMax = 2,
					step = 0.01,
					isPercent = true,
					arg = "wlrAnchorSize",
					get = "getProfileOption",
					set = "setProfileOption",
				},
				timeleftheader = {
					type = "header",
					order = 69,
					name = L["Show time left"],
				},
				timeleft = {
					type = "toggle",
					name = L["Show time left"],
					desc = L["Show time left"],
					order = 70,
					arg = "showTimeleft",
					get = "getProfileOption",
					set = "setProfileOption",
					width = "full",
				},
				font = {
					type = 'select',
					dialogControl = 'LSM30_Font',
					name = L["Font"],
					desc = L["Font"],
					values = AceGUIWidgetLSMlists.font,
					arg = "timeleftFont",
					get = "getProfileOption",
					set = "setProfileOption",
					order = 80,
				},
				fontsize = {
					type = "range",
					name = L["Font size"],
					desc = L["Font size"],
					order = 90,
					min = 0.00,
					softMin = 7,
					max = 32,
					step = 1,
					arg = "timeleftFontsize",
					get = "getProfileOption",
					set = "setProfileOption",
				},
			},
		}, -- END output
		isftimer = {
			type = "group",
			order = 5,
			name = L["Improved Soul Fire timer"],
			args = {
				toggle = {
					type = "toggle",
					order = 10,
					name = L["Enable"],
					desc = L["Show Improved Soul Fire timer"],
					arg = "showIsf",
					get = "getProfileOption",
					set = "setProfileOption",
					width = "full",

				},
				configmode = {
					type = "execute",
					name = L["Config Mode"],
					desc = L["Config Mode"],
					order = 20,
					func = "Unlock",
				},
				reset = {
					type = "execute",
					name = L["Reset position"],
					desc = L["Improved Soul Fire reset"],
					order = 30,
					func = "ResetIsfBar",
				},
				combat = {
					type = "toggle",
					name = L["Show only in combat"],
					desc = L["Show only in combat"],
					order = 50,
					arg = "isfInCombat",
					get = "getProfileOption",
					set = "setProfileOption",
				},
				headerAppearance = {
					type = "header",
					name = L["Appearance"],
					order = 60,
				},
				bg = {
					type = 'select',
					dialogControl = 'LSM30_Background',
					name = L["Background"],
					desc = L["Background"],
					order = 70,
					values = AceGUIWidgetLSMlists.background,
					arg = "isfBg",
					get = "getProfileOption",
					set = "setProfileOption",

				},
				bgcolor = {
					type = "color",
					name = L["Background color"],
					desc = L["Background color"],
					order = 80,
					hasAlpha = true,
					arg = "isfBgColor",
					get = "getProfileOptionColor",
					set = "setProfileOptionColor",
				},
				texture = {
					type = 'select',
					dialogControl = 'LSM30_Statusbar',
					name = L["Texture"],
					desc = L["Texture"],
					order = 90,
					values = AceGUIWidgetLSMlists.statusbar,
					arg = "isfTexture",
					get = "getProfileOption",
					set = "setProfileOption",
				},
				alpha = {
					type = "range",
					name = L["Frame alpha"],
					desc = L["Frame alpha"],
					order = 100,
					min = 0.0,
					softMin = 0.25,
					max = 1.0,
					step = 0.05,
					isPercent = true,
					arg = "isfAlpha",
					get = "getProfileOption",
					set = "setProfileOption",
				},
				headerSize = {
					type = "header",
					name = L["Size"],
					order = 110,
				},
				width = {
					type = "range",
					name = L["Width"],
					desc = L["Width"],
					order = 120,
					min = 0.00,
					max = 1000,
					softMax = 400,
					step = 1,
					arg = "isfWidth",
					get = "getProfileOption",
					set = "setProfileOption",
				},
				height = {
					type = "range",
					name = L["Height"],
					desc = L["Height"],
					order = 130,
					min = 0.00,
					max = 100,
					softMax = 50,
					step = 1,
					arg = "isfHeight",
					get = "getProfileOption",
					set = "setProfileOption",
				},
				headerFont = {
					type = "header",
					name = L["Font"],
					order = 140,
				},
				font = {
					type = 'select',
					dialogControl = 'LSM30_Font',
					name = L["Font"],
					desc = L["Font"],
					values = AceGUIWidgetLSMlists.font,
					arg = "isfFont",
					get = "getProfileOption",
					set = "setProfileOption",
					order = 150,
				},
				fontsize = {
					type = "range",
					name = L["Font size"],
					desc = L["Font size"],
					order = 160,
					min = 0.00,
					softMin = 7,
					max = 32,
					step = 1,
					arg = "isfFontSize",
					get = "getProfileOption",
					set = "setProfileOption",
				},
				textorientation = {
					type = "select",
					name = L["Text orientation"],
					desc = L["Text orientation"],
					order = 170,
					values = TextPositions,
					arg = "isfTextPosition",
					get = "getProfileOption",
					set = "setProfileOption",
				},
			},
		}, -- END Isf
		-- cdbar
		cooldowns = {
			type = "group",
			order = 6,
			name = L["Cooldowns"],
			args = {
				show = {
					type = "toggle",
					order = 10,
					name = L["Enable"],
					desc = L["Enable"],
					arg = "showCooldowns",
					get = "getProfileOption",
					set = "setProfileOption",
					width = "full",
				},
				configmode = {
					type = "execute",
					name = L["Config Mode"],
					desc = L["Config Mode"],
					order = 20,
					func = "Unlock",
				},
				reset = {
					type = "execute",
					name = L["Reset position"],
					desc = L["Reset position"],
					order = 30,
					func = "ResetCooldowns",
				},
				growup = {
					type = "toggle",
					order = 40,
					name = L["Grow up"],
					desc = L["Grow up"],
					arg = "CDGrowUp",
					get = "getProfileOption",
					set = "setProfileOption",
				},
				headerAppearance = {
					type = "header",
					name = L["Appearance"],
					order = 50,
				},
				bg = {
					type = 'select',
					dialogControl = 'LSM30_Background',
					name = L["Background"],
					desc = L["Background"],
					order = 60,
					values = AceGUIWidgetLSMlists.background,
					arg = "cdBg",
					get = "getProfileOption",
					set = "setProfileOption",

				},
				bgcolor = {
					type = "color",
					name = L["Background color"],
					desc = L["Background color"],
					order = 70,
					hasAlpha = true,
					arg = "cdBgColor",
					get = "getProfileOptionColor",
					set = "setProfileOptionColor",
				},
				texture = {
					type = 'select',
					dialogControl = 'LSM30_Statusbar',
					name = L["Texture"],
					desc = L["Texture"],
					order = 80,
					values = AceGUIWidgetLSMlists.statusbar,
					arg = "cdTexture",
					get = "getProfileOption",
					set = "setProfileOption",
				},
				alpha = {
					type = "range",
					name = L["Frame alpha"],
					desc = L["Frame alpha"],
					order = 90,
					min = 0.0,
					softMin = 0.25,
					max = 1.0,
					step = 0.05,
					isPercent = true,
					arg = "cdAlpha",
					get = "getProfileOption",
					set = "setProfileOption",
				},
				headerSize = {
					type = "header",
					name = L["Size"],
					order = 100,
				},
				width = {
					type = "range",
					name = L["Width"],
					desc = L["Width"],
					order = 110,
					min = 0.00,
					max = 1000,
					softMax = 400,
					step = 1,
					arg = "cdWidth",
					get = "getProfileOption",
					set = "setProfileOption",
				},
				height = {
					type = "range",
					name = L["Height"],
					desc = L["Height"],
					order = 120,
					min = 0.00,
					max = 100,
					softMax = 50,
					step = 1,
					arg = "cdHeight",
					get = "getProfileOption",
					set = "setProfileOption",
				},
				headerFont = {
					type = "header",
					name = L["Font"],
					order = 130,
				},
				font = {
					type = 'select',
					dialogControl = 'LSM30_Font',
					name = L["Font"],
					desc = L["Font"],
					values = AceGUIWidgetLSMlists.font,
					arg = "cdFont",
					get = "getProfileOption",
					set = "setProfileOption",
					order = 140,
				},
				fontsize = {
					type = "range",
					name = L["Font size"],
					desc = L["Font size"],
					order = 150,
					min = 0.00,
					softMin = 7,
					max = 32,
					step = 1,
					arg = "cdFontSize",
					get = "getProfileOption",
					set = "setProfileOption",
				},
				textorientation = {
					type = "select",
					name = L["Text orientation"],
					desc = L["Text orientation"],
					order = 160,
					values = TextPositions,
					arg = "cdTextPosition",
					get = "getProfileOption",
					set = "setProfileOption",
				},
				cooldowns = {
					type = "group",
					order = 1,
					name = L["Cooldown setup"],
					args = {
						addcooldown = {
							name = L["Add a Spell"],
							desc = L["Add a new spell to the list by entering the Spell-Id here."],
							type = "input",
							order = 10,
							get = false,
							set = "AddCooldown",
							width = "double",
						},
						selectspell = {
							name = "",
							desc = "",
							type = "multiselect",
							order = 20,
							get = "GetCurrentListCDs",
							set = "SetCurrentListCDs",
							values = "GetListCDs",
							width = "double",
						},
						removespell = {
							name = L["Remove Spell"],
							desc = L["Remove the selected spell from the list."],
							type = "execute",
							func = "RemoveCooldown",
							order = 30,
						},
						customdesc = {
							order = 100,
							name = L["Use spell-ids from wowhead.com's Urls, e.g. Devious Minds: http://www.wowhead.com/spell=70840 => Spell-Id: 70840"],
							type = "description",
						},
					},
				},
			},
		},
		-- END cdbar
		-- darkintent
		darkintent = {
            type = "group",
			order = 7,
            name = L["Dark Intent tracker"],
            args = {
				show = {
					type = "toggle",
					order = 10,
					name = L["Enable"],
					desc = L["Show Dark Intent tracker"],
					arg = "showDarkIntentFrame",
					get = "getProfileOption",
					set = "setProfileOption",
					width = "full",
				},
				configmode = {
					type = "execute",
					name = L["Config Mode"],
					desc = L["Config Mode"],
					order = 20,
					func = "Unlock",
				},
				reset = {
					type = "execute",
					name = L["Reset position"],
					desc = L["Dark Intent tracker reset"],
					order = 30,
					func = "ResetDiFrame",
				},
				realm = {
					type = "toggle",
					name = L["Show realm"],
					desc = L["Show realm"],
					order = 40,
					arg = "diFrameShowRealm",
					get = "getProfileOption",
					set = "setProfileOption",
				},
				headerAppearance = {
					type = "header",
					name = L["Appearance"],
					order = 50,
				},
				bg = {
					type = 'select',
					dialogControl = 'LSM30_Background',
					name = L["Background"],
					desc = L["Background"],
					order = 60,
					values = AceGUIWidgetLSMlists.background,
					arg = "diBg",
					get = "getProfileOption",
					set = "setProfileOption",
				},
				bgcolor = {
					type = "color",
					name = L["Background color"],
					desc = L["Background color"],
					order = 70,
					hasAlpha = true,
					arg = "diBgColor",
					get = "getProfileOptionColor",
					set = "setProfileOptionColor",
				},
				border = {
					type = 'select',
					dialogControl = 'LSM30_Border',
					name = L["Border"],
					desc = L["Border"],
					order = 80,
					values = AceGUIWidgetLSMlists.border,
					arg = "diBorder",
					get = "getProfileOption",
					set = "setProfileOption",
				},
				alpha = {
					type = "range",
					name = L["Frame alpha"],
					desc = L["Frame alpha"],
					order = 90,
					min = 0.0,
					softMin = 0.25,
					max = 1.0,
					step = 0.05,
					isPercent = true,
					arg = "diFrameAlpha",
					get = "getProfileOption",
					set = "setProfileOption",
				},
				headerSize = {
					type = "header",
					name = L["Size"],
					order = 100,

				},
				size = {
					type = "range",
					name = L["Frame size"],
					desc = L["Frame size"],
					order = 110,
					min = 0.01,
					softMin = 0.5,
					max = 5,
					softMax = 2,
					step = 0.01,
					isPercent = true,
					arg = "diFrameSize",
					get = "getProfileOption",
					set = "setProfileOption",
				},
				extrawidth = {
					type = "range",
					name = L["Extra width"],
					desc = L["Extra width"],
					order = 120,
					min = 0.00,
					max = 1000,
					softMax = 100,
					step = 1,
					arg = "diExtraWidth",
					get = "getProfileOption",
					set = "setProfileOption",
				},
				headerFont = {
					type = "header",
					name = L["Font"],
					order = 130,
				},
				font = {
					type = 'select',
					dialogControl = 'LSM30_Font',
					name = L["Font"],
					desc = L["Font"],
					values = AceGUIWidgetLSMlists.font,
					arg = "diFont",
					get = "getProfileOption",
					set = "setProfileOption",
					order = 140,
				},
				fontsize = {
					type = "range",
					name = L["Font size"],
					desc = L["Font size"],
					order = 150,
					min = 0.00,
					softMin = 7,
					max = 32,
					step = 1,
					arg = "diFontSize",
					get = "getProfileOption",
					set = "setProfileOption",
				},
				ttheader = {
					type = "header",
					name = L["Tooltip"],
					order = 160,
					width = "full",
				},
				ttshow = {
					type = "toggle",
					name = L["Show tooltip"],
					desc = L["Show tooltip"],
					order = 170,
					arg = "diTTShow",
					get = "getProfileOption",
					set = "setProfileOption",
				},
				ttspell = {
					type = "toggle",
					name = L["Show spell tooltip"],
					desc = L["Show spell tooltip"],
					order = 180,
					arg = "diTTShowSpell",
					get = "getProfileOption",
					set = "setProfileOption",
				},
				ttanchor = {
					type = "select",
					name = L["Tooltip Position"],
					desc = L["Tooltip Position"],
					order = 190,
					values = TooltipPositions,
					arg = "diTTPosition",
					get = "getProfileOption",
					set = "setProfileOption",
				},
			},
		}, -- END Dark Intent
    },
}
-- END Options

function WarlockReminder:OnProfileChanged(event, database, newProfileKey)
	wlrDB = self.db.profile
	self:AnchorSetup()
	self:CDSetup()
	self:CustomSetup()
	self:DiFrameSetup()
	self:IsfSetup()
end

function WarlockReminder:OnProfileReset(event, database, newProfileKey)
	wlrDB = self.db.profile
	self:CreateDefaultTables()
	self:CreateCooldownBars()
	self:Unlock()
end

function WarlockReminder:OnNewProfile(event, database, newProfileKey)
	wlrDB = self.db.profile
	self:CreateDefaultTables()
	self:CreateCooldownBars()
	self:Unlock()
end

-- Setup options
function WarlockReminder:SetUpOptions()
	local wlrprofile = LibStub('AceDBOptions-3.0'):GetOptionsTable(self.db)
	-- Add dual-spec support
	local LibDualSpec = LibStub("LibDualSpec-1.0", true)
	if(LibDualSpec) then
		LibDualSpec:EnhanceDatabase(self.db, "WarlockReminder")
		LibDualSpec:EnhanceOptions(wlrprofile, self.db)
	end
	
	local config = LibStub("AceConfig-3.0")
	config:RegisterOptionsTable("WarlockReminder", wlroptions, {"wlr", "warlockreminder"})
	
	local registry = LibStub("AceConfigRegistry-3.0")
	-- Add option windows
    registry:RegisterOptionsTable("WarlockReminder Main", wlroptions)
	registry:RegisterOptionsTable("WarlockReminder Profiles", wlrprofile)
	
	local dialog = LibStub("AceConfigDialog-3.0")
	self.optionFrames = {
		main = dialog:AddToBlizOptions("WarlockReminder Main", "WarlockReminder"),
		profile = dialog:AddToBlizOptions("WarlockReminder Profiles", L["Profiles"], "WarlockReminder"),
	}
end

-- Get Function
function WarlockReminder:getProfileOption(info)
	return wlrDB[info.arg]
end

-- Set Function
function WarlockReminder:setProfileOption(info, value)
	wlrDB[info.arg] = value
	if(info.uiType == "cmd") then
		WarlockReminder:Print(L["|cffffff7f%s|r is now set to |cffffff7f[%s]|r"]:format(info.option.name, tostring(value)))
	end
	self:DiFrameSetup()
	self:CustomSetup()
	self:AnchorSetup()
	self:CDSetup()
	self:IsfSetup()
end

-- Color picker
function WarlockReminder:getProfileOptionColor(info)
	local c = wlrDB[info.arg]
	return c.r, c.g, c.b, c.a
end

function WarlockReminder:setProfileOptionColor(info, r, g, b, a)
	wlrDB[info.arg] = {["r"] = r, ["g"] = g, ["b"] = b, ["a"] = a}
	self:DiFrameSetup()
	self:CustomSetup()
	self:AnchorSetup()
	self:IsfSetup()
end

